package fr.inria.gemo.axml.optimax;

import org.w3c.dom.Document;

import fr.inria.gemo.axml.optimax.helping.Utilities;
import fr.inria.gemo.axml.optimax.info.IDProvider;
import fr.inria.gemo.axml.optimax.info.IDProviderImpl;
import fr.inria.gemo.axml.optimax.info.P2PInformation;
import fr.inria.gemo.axml.optimax.info.P2PInformationImpl;
import fr.inria.gemo.axml.optimax.io.FileManager;
import fr.inria.gemo.axml.optimax.strategy.Strategy;

public class DummyMain {

	/**
	 * Args[0]: the name of the input AXML file
	 * Args[1]: the name of the strategy file. If none is given, a default
	 * strategy (say, with depth-first) will be used.
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length < 1){
			System.out.println("Usage: DummyMain axmlDoc.xml [strategyFile.xml | (Parameters.DEPTH_FIRST|Parameters.BREADTH_FIRST))]");
			return;
		}
		IDProvider iDProviderInstance = new IDProviderImpl();
		P2PInformation p2PInformationInstance = new P2PInformationImpl();
		
		StringBuffer inputFileName = new StringBuffer(args[0]);
		
		FileManager fileManagerInstance = FileManager.getInstance();
		Document domOfAxml = fileManagerInstance.getDomFromXmlFile(inputFileName.toString());

		Optimax op = new Optimax(iDProviderInstance, p2PInformationInstance);
		
//		Utilities.createGraphicalRepresentationOfAxmlFile(domOfAxml);
//		System.exit(0);
		
//		Document result = null;
//		try{
//			result = op.optimize(domOfAxml,10);
//		}
//		catch(Exception e){
//			e.printStackTrace();
//		}
//		System.exit(0);
//		
//		System.out.println(Utilities.DomToStringSerializerWithIdentation(result));
//		System.out.println(Utilities.createGraphicalRepresentationOfAxmlFile(result));
//		System.exit(0);
		
		Strategy strat = null;
		if (args.length > 1){
			if (args[1].endsWith(".xml")){
				strat = new Strategy(args[1]);
			}
			else{
				if (args[1].compareTo(Parameters.BREADTH_FIRST) == 0 ||
						args[1].compareTo(Parameters.DEPTH_FIRST) == 0){
					strat = Strategy.defaultStrategy(args[1]);
				}
			}
		}
		else{
			strat = Strategy.defaultStrategy(Parameters.DEPTH_FIRST);
		}
		
//		Document optimPlan = op.optimize(domOfAxml, args[1],  0);
//		Utilities.createGraphicalRepresentationOfAxmlFile(optimPlan);
//		System.out.println(Utilities.DomToStringSerializerWithIdentation(optimPlan));
		
		try{
			op.optimizeAndStoreGraphizFiles(domOfAxml, strat);
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
}
