package fr.inria.gemo.axml.optimax.adocument;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;

public class ADNodeCounter {
	static private int numberOfNodes = 0;
	static private int numberOfCreatedNodes = 0;
	static private int numberOfGCNodes = 0;

	static public synchronized void increaseNumberOfNodes()
	{
		numberOfNodes ++;
		numberOfCreatedNodes ++;
//		System.out.println("A node was generated (number of created nodes " + numberOfCreatedNodes + ")");
	}
	
	static public synchronized void decreaseNumberOfNodes()
	{
		numberOfNodes --;
		numberOfGCNodes ++;
//		System.out.println("A node was garbadge collected (number of gc nodes " + numberOfGCNodes + ")");
	}
	
	static public int getNumberOfNodes()
	{
		return numberOfNodes;
	}
	
	static public int getNumberOfCreatedNodes()
	{
		return numberOfCreatedNodes;
	}
	
	static public int getNumberOfGCNodes()
	{
		return numberOfGCNodes;
	}
	
	static public int calculateADNodesOfADocument(ADocument givenADoc)
	{
		int counter = 0;
		
		ADNode rootOfADoc = givenADoc.getRootOfADoc();
		LinkedList<ADNode> aDNodesToBeVisited = new LinkedList<ADNode>();
		aDNodesToBeVisited.add(rootOfADoc);
		
		while(!aDNodesToBeVisited.isEmpty())
		{
			ADNode currADNode = aDNodesToBeVisited.removeFirst();
			counter++;
			aDNodesToBeVisited.addAll(currADNode.getChildren());
		}
		
		return counter;
	}
	
	static public int calculateADNodesOfADocumentSet(Set<ADocument> givenSet)
	{
		int counter = 0;
		
		Iterator<ADocument> givenSetIter = givenSet.iterator();
		while(givenSetIter.hasNext())
		{
			ADocument currADoc = givenSetIter.next();
			counter += calculateADNodesOfADocument(currADoc);
		}
		
		return counter;
	}
}
