package fr.inria.gemo.axml.optimax.adocument;

import fr.inria.gemo.axml.optimax.helping.Utilities;

public class IdContainer {
	public String nodeID;
	public String docID;
	public String peerID;
	
	public IdContainer()
	{
		nodeID = new String();
		docID = new String();
		peerID = new String();
	}
	
	public IdContainer(IdContainer givenID)
	{
		nodeID = new String(givenID.nodeID);
		docID = new String(givenID.docID);
		peerID = new String(givenID.peerID);
	}
	
	public IdContainer(String givenNodeID, String givenDocID, String givenPeerID)
	{
		nodeID = new String(givenNodeID);
		docID = new String(givenDocID);
		peerID = new String(givenPeerID);
	}
	
	public boolean isEmpty()
	{
		if(this.nodeID.length() == 0 && this.docID.length() == 0 && this.peerID.length() == 0)
			return true;
		else
			return false;
	}
	
	public void setNodeID(String givenNodeID)
	{
		this.nodeID = new String(givenNodeID);
	}

	public void setDocID(String givenDocID)
	{
		this.docID = new String(givenDocID);
	}

	public void setPeerID(String givenPeerID)
	{
		this.peerID = new String(givenPeerID);
	}

	public boolean equals(Object o)
	{
		if(o instanceof IdContainer)
		{
			IdContainer givenObject = (IdContainer) o;
			if(this.nodeID.equals(givenObject.nodeID) && this.docID.equals(givenObject.docID) && this.peerID.equals(givenObject.peerID))
				return true;
		}
		return false;
	}
	
	public int hashCode()
	{
//		return 0;
		return Utilities.amodN(this.nodeID.hashCode() + this.docID.hashCode() + this.peerID.hashCode(), Integer.MAX_VALUE).intValue();
	}
	
	public String toString(){
		return new String(this.nodeID + "." + this.docID + "." + this.peerID);
	}
}
