package fr.inria.gemo.axml.optimax.helping;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.adocument.RuleDescriptionContainer;

public class EqualPlanFinder {

	public static List<List<String>> findEqualPlansIfThereAreOnlyDelegations(List<ADocument> givenListOfADocs)
	{
		List<List<String>> pairOfADocsThatShouldBeEqual = new ArrayList<List<String>>();
		
		for(int i=0; i<givenListOfADocs.size(); i++)
		{
			ADocument outerDoc = givenListOfADocs.get(i);
			for(int j=i+1; j<givenListOfADocs.size(); j++)
			{
				ADocument innerDoc = givenListOfADocs.get(j);

//				if(outerDoc == innerDoc)
//				{
//					System.out.println("xaxa");
//				}
				
				if(compare2DelegationRuleListsForEquality(outerDoc.getRulesApplied(), innerDoc.getRulesApplied()))
				{
					List<String> newPair = new ArrayList<String>();
					newPair.add(Integer.toString(outerDoc.getADocNumber()));
					newPair.add(Integer.toString(innerDoc.getADocNumber()));
					pairOfADocsThatShouldBeEqual.add(newPair);
				}
			}
		}
		
		return pairOfADocsThatShouldBeEqual;
	}
	
	private static boolean compare2DelegationRuleListsForEquality(List<RuleDescriptionContainer> ruleList1, List<RuleDescriptionContainer> ruleList2)
	{
		if(ruleList1.isEmpty() && ruleList2.isEmpty())
			return true;
		
		List<RuleDescriptionContainer> copyOfRuleList1 = new ArrayList<RuleDescriptionContainer>(ruleList1);
		List<RuleDescriptionContainer> copyOfRuleList2 = new ArrayList<RuleDescriptionContainer>(ruleList2);
		
		Iterator<RuleDescriptionContainer> copyOfRuleList1Iter = copyOfRuleList1.iterator();
		while(copyOfRuleList1Iter.hasNext())
		{
			RuleDescriptionContainer currRule1 = copyOfRuleList1Iter.next();
			Iterator<RuleDescriptionContainer> copyOfRuleList2Iter = copyOfRuleList2.iterator();
			while(copyOfRuleList2Iter.hasNext())
			{
				RuleDescriptionContainer currRule2 = copyOfRuleList2Iter.next();
				// If another delegation for the same service call is found but with diff delegation peer(at the possition
				// at which we expected a deleg of the same sc at the same degeg peer), we abort.
				if(currRule1.nameOfRule.equals("deleg") && currRule2.nameOfRule.equals("deleg") && currRule1.arg1.equals(currRule2.arg1) && !currRule1.arg2.equals(currRule2.arg2))
					return false;
				// otherwise if it is the same delegation, we remove it from the lists and
				// we continue our check
				if(currRule1.nameOfRule.equals("deleg") && currRule2.nameOfRule.equals("deleg") && currRule1.arg1.equals(currRule2.arg1) && currRule1.arg2.equals(currRule2.arg2))
				{
					// the rule is delegation which is applied on the same
					// service and the delegation peer is the same. So we
					// remove this rule
					copyOfRuleList1Iter.remove();
					copyOfRuleList2Iter.remove();
					break;
				}
			}
		}
		
		if(copyOfRuleList1.isEmpty() && copyOfRuleList2.isEmpty())
			return true;
		else
			return false;
	}
}
