package fr.inria.gemo.axml.optimax.helping;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

public class ExtendedLinkedList<E> extends LinkedList<E> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	LinkedList<E> insideList = new LinkedList<E>();

	public boolean add(E o) {
		return insideList.add(o);
	}

	public void add(int index, E element) {
		insideList.add(index, element);
	}

	public boolean addAll(Collection<? extends E> c) {
		return insideList.addAll(c);
	}

	public boolean addAll(int index, Collection<? extends E> c) {
		return insideList.addAll(index, c);
	}

	public void addFirst(E o) {
		insideList.addFirst(o);
	}

	public void addLast(E o) {
		insideList.addLast(o);
	}

	public void clear() {
		insideList.clear();
	}

	public Object clone() {
		return insideList.clone();
	}

	public boolean contains(Object o) {
		return insideList.contains(o);
	}
	
	public boolean refContains(Object o) {
		
		Iterator tempIt = insideList.iterator();
		while(tempIt.hasNext())
			if(tempIt.next() == o)
				return true;

		return false;
	}

	public boolean containsAll(Collection<?> c) {
		return insideList.containsAll(c);
	}
	
	public boolean refContainsAll(Collection<?> c) {
		
		Iterator cIter = c.iterator();
		while(cIter.hasNext())
		{
			Object cElem = cIter.next();
			Iterator insideListIter = insideList.iterator();
			while(insideListIter.hasNext())
				if(insideListIter.next() == cElem)
					continue;
			return false;
		}
		return true;
	}

	public E element() {
		return insideList.element();
	}

	public boolean equals(Object o) {
		return insideList.equals(o);
	}

	public E get(int index) {
		return insideList.get(index);
	}

	public E getFirst() {
		return insideList.getFirst();
	}

	public E getLast() {
		return insideList.getLast();
	}

	public int hashCode() {
		return insideList.hashCode();
	}

	public int indexOf(Object o) {
		return insideList.indexOf(o);
	}

	public boolean isEmpty() {
		return insideList.isEmpty();
	}

	public Iterator<E> iterator() {
		return insideList.iterator();
	}

	public int lastIndexOf(Object o) {
		return insideList.lastIndexOf(o);
	}

	public ListIterator<E> listIterator() {
		return insideList.listIterator();
	}

	public ListIterator<E> listIterator(int index) {
		return insideList.listIterator(index);
	}

	public boolean offer(E o) {
		return insideList.offer(o);
	}

	public E peek() {
		return insideList.peek();
	}

	public E poll() {
		return insideList.poll();
	}

	public E remove() {
		return insideList.remove();
	}

	public E remove(int index) {
		return insideList.remove(index);
	}

	public boolean remove(Object o) {
		return insideList.remove(o);
	}
	
	public boolean refRemove(Object o) {
		for(int i=0; i<insideList.size(); i++)
		{
			if(insideList.get(i) == o)
			{
				insideList.remove(i);
				return true;
			}
		}
		
		return false;
	}

	public boolean removeAll(Collection<?> c) {
		return insideList.removeAll(c);
	}

	public E removeFirst() {
		return insideList.removeFirst();
	}

	public E removeLast() {
		return insideList.removeLast();
	}

	public boolean retainAll(Collection<?> c) {
		return insideList.retainAll(c);
	}

	public E set(int index, E element) {
		return insideList.set(index, element);
	}

	public int size() {
		return insideList.size();
	}

	public List<E> subList(int fromIndex, int toIndex) {
		return insideList.subList(fromIndex, toIndex);
	}

	public Object[] toArray() {
		return insideList.toArray();
	}

	public <T> T[] toArray(T[] a) {
		return insideList.toArray(a);
	}

	public String toString() {
		return insideList.toString();
	}
}
