package fr.inria.gemo.axml.optimax.helping;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.namespace.NamespaceContext;
import com.sun.org.apache.xerces.internal.util.NamespaceSupport;

public class NamespaceContextWrapper implements NamespaceContext{
		private NamespaceSupport support = null;
		
		public NamespaceContextWrapper(NamespaceSupport support) {
			this.support = support;
		}
		
		public String getNamespaceURI(String prefix) {			
			return support.getURI(prefix.intern());
		}
		
		public String getPrefix(String namespaceURI) {
			return support.getPrefix(namespaceURI);
		}
		
		public Iterator getPrefixes(String namespaceURI) {
			List<String> prefix = new ArrayList<String>();
			prefix.add(getPrefix(namespaceURI));
			return prefix.iterator();
		}
		
		@Override
		public String toString() {
			StringBuffer sb = new StringBuffer("[");
			
			for (int i = 0; i < support.getDeclaredPrefixCount(); i++) {
				sb.append("("+support.getDeclaredPrefixAt(i)+", "+support.getURI(support.getDeclaredPrefixAt(i))+")");
			}
			sb.append("]");
			return sb.toString();
		}
}
