package fr.inria.gemo.axml.optimax.helping;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import fr.inria.gemo.axml.optimax.adocument.Service;

public class ServiceMapper {
	// Mapping a service name to service difinition (key.serviceName -> key)
	private static Map<String, ArrayList<Service>> nameToServiceMap;
	
	// Mapping a service definition to another equal service definitions (key -> value)
	private static Map<Service, ArrayList<Service>> serviceToServiceMap; 
	
	ServiceMapper()
	{
		// In the following map we store mappings of the type key.serviceName -> key 
		nameToServiceMap = new HashMap<String, ArrayList<Service>>();
		// In the following map we store mappings of the type key -> value
		serviceToServiceMap = new HashMap<Service, ArrayList<Service>>();
		
		System.out.println("I am initialized!!");
	}
	
//	ServiceMapper(String serviceMappingFileName)
//	{
//		this();
//		loadingServiceMapperWithDataFromFile(serviceMappingFileName);
//	}
	
//	private void loadingServiceMapperWithDataFromFile(String serviceMappingFileName)
//	{
//		FileManager myFileManagerInstance = FileManager.getInstance();
//		Map<Service, ArrayList<Service>> returnedMappings = myFileManagerInstance.returnMappings(serviceMappingFileName);
//		
//		System.out.println("Mappings loaded from file " + returnedMappings);
//		
//		Set<Service> serviceSet = returnedMappings.keySet();
//		Iterator serviceSetIterator = serviceSet.iterator();
//		while(serviceSetIterator.hasNext())
//		{
//			Service keyService = (Service)serviceSetIterator.next();
//			ArrayList<Service> valuesArrayList = returnedMappings.get(keyService);
//			
//			Iterator valuesArrayListIterator = valuesArrayList.iterator();
//			while(valuesArrayListIterator.hasNext())
//			{
//				Service valueService = (Service)valuesArrayListIterator.next();
//				addToMap(keyService, valueService);
//			}
//		}
//	}
	
	// Creating a mapping in our maps between key <-> value
	void addToMap(Service key, Service value)
	{
		// If there is service with the same key name in our maps
		if(nameToServiceMap.containsKey(key.getServiceName().toString()) == true)
		{ 
			ArrayList<Service> myTempNameToServiceMapArrayList = nameToServiceMap.get(key.getServiceName().toString());
			
			// If there is not the same key definition 
			if(myTempNameToServiceMapArrayList.contains(key) == false)
			{
				// We add the new key service definition to the nameToServiceMap
				myTempNameToServiceMapArrayList.add(key);
				// And then we add the new key service definition and the value service definition to the serviceToServiceMap
				ArrayList<Service> myTempServiceToServiceMapArrayList = new ArrayList<Service>();
				myTempServiceToServiceMapArrayList.add(value);
				serviceToServiceMap.put(key, myTempServiceToServiceMapArrayList);
			}
			// If there is the same key definition
			else
			{
				// maybe there is not the same value related to the specific key
				ArrayList<Service> myTempServiceToServiceMapArrayList = serviceToServiceMap.get(key);
				if(myTempServiceToServiceMapArrayList.contains(value) == false)
					myTempServiceToServiceMapArrayList.add(value);
			}
		}
		// If there is no service with the specific name in our maps
		else
		{
			// We first create a record at the nameToServiceMap
			ArrayList<Service> myTempNameToServiceMapArrayList = new ArrayList<Service>();
			myTempNameToServiceMapArrayList.add(key);
			nameToServiceMap.put(key.getServiceName().toString(), myTempNameToServiceMapArrayList);
			
			// and then we create a record at the serviceToServiceMap
			ArrayList<Service> myTempServiceToServiceMapArrayList = new ArrayList<Service>();
			myTempServiceToServiceMapArrayList.add(value);
			serviceToServiceMap.put(key, myTempServiceToServiceMapArrayList);
		}
	}
	
	public ArrayList<Service> getKeyServiceDefinitionsFromMap(String keyServiceName)
	{
//		System.out.println("nameToServiceMap :" + nameToServiceMap);
		return nameToServiceMap.get(keyServiceName);
//		return serviceToServiceMap.get(key);
	}
	
	public ArrayList<Service> getValueDefinitionsFromMap(Service key)
	{
		return serviceToServiceMap.get(key);
	}
	
	public void emptySets()
	{
		nameToServiceMap.clear();
		serviceToServiceMap.clear();
	}
	
//	void spyrosAdd()
//	{
//		Service mykeySevice = new Service();
//		mykeySevice.setServiceName(new StringBuffer("q"));
//		mykeySevice.setExecutionPeer(new StringBuffer("any"));
//		ArgumentObject mykeyServiceArgumentObject1 = new ArgumentString(new StringBuffer("$1"));
//		ArgumentObject mykeyServiceArgumentObject2 = new ArgumentString(new StringBuffer("$2"));
//		mykeySevice.addArgument(mykeyServiceArgumentObject1);
//		mykeySevice.addArgument(mykeyServiceArgumentObject2);
//		
//		Service mytargetSevice = new Service();
//		mytargetSevice.setServiceName(new StringBuffer("q'"));
//		mytargetSevice.setExecutionPeer(new StringBuffer("any"));
//
//		ArrayList<ArgumentObject> tempArraylist  = new ArrayList<ArgumentObject>();
//		tempArraylist.add(new ArgumentString(new StringBuffer("$1")));
//		tempArraylist.add(new ArgumentString(new StringBuffer("$2")));
//		ArgumentObject mytargetSeviceArgumentObject1 = new ArgumentService(new Service(false, new StringBuffer("q''"), new StringBuffer("any"), tempArraylist));
//		ArgumentObject mytargetSeviceArgumentObject2 = new ArgumentString(new StringBuffer("arg3"));
//		mytargetSevice.addArgument(mytargetSeviceArgumentObject1);
//		mytargetSevice.addArgument(mytargetSeviceArgumentObject2);
//
//		addToMap(mykeySevice, mytargetSevice);
//	}
}
