package fr.inria.gemo.axml.optimax.helping;

import java.io.IOException;
import java.io.StringWriter;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPathExpressionException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.io.FileManager;
import fr.inria.gemo.axml.optimax.io.input.FileInputModule;
import fr.inria.gemo.axml.optimax.io.output.AXMLDrawingHack;
import fr.inria.gemo.axml.optimax.io.output.ConciseADocumentDrawingModule;
import fr.inria.gemo.axml.optimax.io.output.ConciseADocumentDrawingModule2;
import fr.inria.gemo.axml.optimax.io.output.FileOutputModule;
import fr.inria.gemo.axml.optimax.io.output.GraphvizModule;
import fr.inria.gemo.axml.optimax.io.output.VerboseADocumentDrawingModule;

public class Utilities {
	
	// Creates a nicelly stuctured xml document and returns it
	// as a string. The input is a document
	public static String DomToStringSerializerWithIdentation(Document givenDoc)
	{
		return ElementToStringSerializer(givenDoc.getDocumentElement(), true, false);
	}
	
	// Creates a unstuctured xml document and returns it
	// as a string. The input is a document
	public static String DomToStringSerializerWithoutIdentationAndDeclar(Document givenDoc)
	{
		return ElementToStringSerializer(givenDoc.getDocumentElement(), false, true);
	}

	// Creates a nicelly stuctured xml document and returns it
	// as a string. The input is a node
	public static String ElementToStringSerializer(Element givenElement, boolean identation, boolean omitXmlDeclaration)
	{
		try {
			StringWriter myStrw = new StringWriter();
			Transformer trs = TransformerFactory.newInstance().newTransformer();
			if(identation)
				trs.setOutputProperty(OutputKeys.INDENT, "yes");
			if(omitXmlDeclaration)
				trs.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			
			trs.transform(new DOMSource(givenElement), new StreamResult(myStrw));
			return myStrw.toString();
		} catch (TransformerConfigurationException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (TransformerException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (TransformerFactoryConfigurationError e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		return null;
	}
	
	// Creates a nicelly stuctured xml document and returns it
	// as a string. The input is a node
	public static String OldElementToStringSerializer(Element givenElement, boolean identation, boolean omitXmlDeclaration)
	{
		StringWriter out = new StringWriter();
		OutputFormat of = new OutputFormat("XML","ISO-8859-1",identation);
		
		of.setLineWidth(0);
//		of.setOmitDocumentType(true);
		of.setOmitXMLDeclaration(omitXmlDeclaration);
//		of.setIndenting(true);
//		of.setLineWidth(0);             
//		of.setPreserveSpace(true);
//		of.setIndent(1);
//		of.setIndenting(true);
//		of.setDoctype(null,"testForSkeleton.dtd");
		XMLSerializer serializer = new XMLSerializer(out,of);
//		As a DOM Serializer
		try {
			serializer.asDOMSerializer();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			serializer.serialize(givenElement);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return out.toString();
	}
	
	public static void findPlansThatAreNotCommon(Set<ADocument> firstSet, Set<ADocument> secondSet)
	{
		Set<ADocument> firstSetMinusSecond = new HashSet<ADocument>();
		Set<ADocument> secondSetMinusFirst = new HashSet<ADocument>();
//		Set<ADocument> intersection = new HashSet<ADocument>();
		
		firstSetMinusSecond.addAll(firstSet);
		secondSetMinusFirst.addAll(secondSet);
		
		firstSetMinusSecond.removeAll(secondSet);
		secondSetMinusFirst.removeAll(firstSet);
		
//		intersection.addAll(firstSet);
//		intersection.addAll(secondSet);
//		intersection.removeAll(firstSetMinusSecond);
//		intersection.removeAll(secondSetMinusFirst);
		
//		System.out.println("Size of intersection:" + intersection.size());
		System.out.println("Size of firstSetMinusSecond:" + firstSetMinusSecond.size());
		System.out.println("Size of secondSetMinusFirst:" + secondSetMinusFirst.size());
		
		System.out.println("Size of firstSet:" + firstSet.size());
		System.out.println("Size of secondSet:" + secondSet.size());
		
		if(firstSetMinusSecond.size() == 0 && secondSetMinusFirst.size() == 0)
			System.exit(0);
		
		FileOutputModule.deletePreviousTxtAndJpgFiles();
		
		Iterator<ADocument> firstSetMinusSecondIter = firstSetMinusSecond.iterator();
		while(firstSetMinusSecondIter.hasNext())
		{
			ADocument currADoc = firstSetMinusSecondIter.next();
			FileManager.createDebugOutputImage(currADoc, new String("firstSetMinusSecond" + currADoc.getADocNumber()));
		}
		
		Iterator<ADocument> secondSetMinusFirstIter = secondSetMinusFirst.iterator();
		while(secondSetMinusFirstIter.hasNext())
		{
			ADocument currADoc = secondSetMinusFirstIter.next();
			FileManager.createDebugOutputImage(currADoc, new String("secondSetMinusFirst" + currADoc.getADocNumber()));
		}
		
		Iterator<ADocument> firstSetIter = firstSet.iterator();
		while(firstSetIter.hasNext())
		{
			ADocument currADoc = firstSetIter.next();
			FileManager.createDebugOutputImage(currADoc, new String("firstSet" + currADoc.getADocNumber()));
		}
		
		Iterator<ADocument> secondSetIter = secondSet.iterator();
		while(secondSetIter.hasNext())
		{
			ADocument currADoc = secondSetIter.next();
			FileManager.createDebugOutputImage(currADoc, new String("secondSet" + currADoc.getADocNumber()));
		}
		
//		Iterator<ADocument> intersectionIter = intersection.iterator();
//		counter = 0;
//		while(intersectionIter.hasNext())
//		{
//			FileManager.createDebugOutputImage(intersectionIter.next(), new String("intersection" + counter));
//			counter++;
//		}
	}
	
	public static byte[] oldCreateGraphicalRepresentationOfAxmlFile(Document givenAxmlFile)
	{
		ADocument aDocOfAxmlFile = null;
		try {
			aDocOfAxmlFile = FileInputModule.constructADocFromAxmlDom(givenAxmlFile);
		} catch (XPathExpressionException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		VerboseADocumentDrawingModule.createOutputImage(aDocOfAxmlFile, "tempOutputImage");
		try {
			return FileInputModule.readDataFromBinaryFile("tempOutputImage.jpg");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return new byte[0];
	}

	public static byte[] createGraphicalRepresentationOfAxmlFile(Document givenAxmlFile)
	{
		ADocument aDocOfAxmlFile = null;
		try {
			aDocOfAxmlFile = FileInputModule.constructADocForPicsFromAxmlDom(givenAxmlFile);
		} catch (XPathExpressionException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		ConciseADocumentDrawingModule2.createOutputImage(aDocOfAxmlFile, "tempOutputImage");
		try {
			return FileInputModule.readDataFromBinaryFile("tempOutputImage.jpg");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return new byte[0];
	}
	
	public static byte[] old2createGraphicalRepresentationOfAxmlFile(Document givenAxmlFile)
	{
		StringBuffer sb = new StringBuffer();
		AXMLDrawingHack.print(sb, givenAxmlFile);
		
		FileOutputModule.saveDataFromStringBufferToFile(sb, "tempOutputImage" + ".txt");
		GraphvizModule.runGraphviz("tempOutputImage");
		try {
			return FileInputModule.readDataFromBinaryFile("tempOutputImage.jpg");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return new byte[0];
	}

	
	public static Long amodN(long A, long N)
	{
		if(N < 0)
			return null;
		
		long result = A % N;
		if(result < 0)
			result += N;
		
		return result;
	}
	
	public static Integer invertInt(int givenInt)
	{
		// We do this check because abs(Integer.MIN_VALUE)
		// == Integer.MAX_VALUE +1
		if(givenInt == Integer.MIN_VALUE)
			return null;
		
		int returningValue = 0 - givenInt;
		return returningValue;
	}
	
	public static int modHashCode(String givenStr)
	{
		int returningValue = 0;
		
		for(int i=0; i<givenStr.length(); i++)
			returningValue = amodN((returningValue + givenStr.codePointAt(i)), Integer.MAX_VALUE).intValue();

		return returningValue;
	}
}
