package fr.inria.gemo.axml.optimax.info;

import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.LinkedList;

import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.adocument.EqualADocAtom;
import fr.inria.gemo.axml.optimax.adocument.RuleDescriptionContainer;

public class Statistics {

	public static float minimumSimpleCostOfAlreadyVisitedPlans;
	public static float minimumServiceAndWeightedNetworkCostOfAlreadyVisitedPlans;
	
	public static LinkedList<Float> listWithMinimumSimpleCostOfAlreadyVisitedPlans;
	public static LinkedList<Float> listWithMinimumServiceAndWeightedNetworkCostOfAlreadyVisitedPlans;

	public static LinkedList<Float> listWithCurrSimpleCostOfAlreadyVisitedPlans;
	public static LinkedList<Float> listWithCurrServiceAndWeightedNetworkCostOfAlreadyVisitedPlans;
	
	public static LinkedList<EqualADocAtom> aDocEqualities;
	public static LinkedHashSet<RuleDescriptionContainer> totalRulesApplied;
	
	public static ADocument cheapestSimpleCostADoc;
	public static ADocument cheapestServiceAndWeightedNetworkCostADoc;
	
	public static LinkedList<Integer> startOfSteps;

	
	static{
		minimumSimpleCostOfAlreadyVisitedPlans = -1;
		minimumServiceAndWeightedNetworkCostOfAlreadyVisitedPlans = -1;
		
		listWithMinimumSimpleCostOfAlreadyVisitedPlans = new LinkedList<Float>();
		listWithMinimumServiceAndWeightedNetworkCostOfAlreadyVisitedPlans = new LinkedList<Float>();
		
		listWithCurrSimpleCostOfAlreadyVisitedPlans = new LinkedList<Float>();
		listWithCurrServiceAndWeightedNetworkCostOfAlreadyVisitedPlans = new LinkedList<Float>();
		
		aDocEqualities = new LinkedList<EqualADocAtom>();
		totalRulesApplied = new LinkedHashSet<RuleDescriptionContainer>();
		
		cheapestSimpleCostADoc = null;
		cheapestServiceAndWeightedNetworkCostADoc = null;
		
		startOfSteps = new LinkedList<Integer>();
	}
}
