package fr.inria.gemo.axml.optimax.io.output;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import fr.inria.gemo.axml.optimax.Parameters;
import fr.inria.gemo.axml.optimax.PlanRepository;
import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.helping.Deleting;
import fr.inria.gemo.axml.optimax.helping.comparators.ComparatorSimpleNetwCost;

public class ADocumentDrawingModule {

	public void createOutputImages(PlanRepository givenPlanRepository)
	{
		Deleting.deletePreviousTxtAndJpgFiles();
		createGraphvizFiles(givenPlanRepository.getADocsAlreadyVisitedSet());
		int i= 0;
		for(Iterator<ADocument> aDocsAlreadyVisitedSetIter = givenPlanRepository.getADocsAlreadyVisitedSet().iterator();aDocsAlreadyVisitedSetIter.hasNext();)
		{
			System.out.println("Creating Image #" + i);
			StringWriter stringWriterInstance = new StringWriter();
			PrintWriter printWriterInstance = new PrintWriter(stringWriterInstance);
			printWriterInstance.printf("%06d",aDocsAlreadyVisitedSetIter.next().getADocNumber());
			GraphvizModule.runGraphviz(stringWriterInstance.toString());
			printWriterInstance.close();
			try 
			{
				stringWriterInstance.close();
			} 
			catch (IOException e) 
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			i++;
		}
	}
	
	@SuppressWarnings("unchecked")
	public void createGraphvizFiles(Set<ADocument> givenSetOfPlans)
	{
		List<ADocument> givenListOfPlans = new ArrayList<ADocument>();
		Iterator<ADocument> givenSetOfPlansIter = givenSetOfPlans.iterator();
		while(givenSetOfPlansIter.hasNext())
			givenListOfPlans.add(givenSetOfPlansIter.next());

		//TODO the sort bellow could be useful
		Collections.sort(givenListOfPlans, new ComparatorSimpleNetwCost());
		
		Iterator<ADocument> planIterator = givenListOfPlans.iterator();
		int counter = 0;
		while(planIterator.hasNext())
		{
			System.out.println("Creating Description For Image #" + counter);
			
			ADocument tempADoc = planIterator.next();
			
			StringWriter stringWriterInstance = new StringWriter();
			PrintWriter printWriterInstance = new PrintWriter(stringWriterInstance);
			printWriterInstance.printf("%06d",tempADoc.getADocNumber());
			if (Parameters.getProperty("graphType").compareTo(Parameters.VERBOSE_GRAPH)==0){
				FileOutputModule.saveDataFromStringBufferToFile(VerboseADocumentDrawingModule.createGraphvizOutput(tempADoc), stringWriterInstance + ".txt");
			}
			else{
				FileOutputModule.saveDataFromStringBufferToFile(ConciseADocumentDrawingModule.createConciseGraphVizOutput(tempADoc), stringWriterInstance + ".txt");
			}
			printWriterInstance.close();
			try 
			{
				stringWriterInstance.close();
			} 
			catch (IOException e) 
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			counter++;
			// NOTE this was added only for debugging purposes
//			if(counter == 10)
//				break;
		}
	}
}
