package fr.inria.gemo.axml.optimax.io.output;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import fr.inria.gemo.axml.optimax.adocument.ADNode;
import fr.inria.gemo.axml.optimax.adocument.Service;
import fr.inria.gemo.axml.optimax.adocument.SimpleNode;
import fr.inria.gemo.axml.optimax.io.input.FileInputModule;
import fr.inria.gemo.axml.optimax.strategy.Step;

public class AXMLDrawingHack {

	static public void print(StringBuffer sb, Document givenDoc) {

		NodeList docChildren = givenDoc.getChildNodes();
		Node root = docChildren.item(0);

		toDotString(root, sb, false, -1, 0);

		sb.insert(0, "graph \"plan\" {graph\n");
		sb.append("}");
	}

	static private int toDotString(Node n, StringBuffer sb, boolean underReceive, int parentID, int nextAvailable) {
		if (n.getNodeType() != Node.ATTRIBUTE_NODE
				&& n.getNodeType() != Node.ELEMENT_NODE) {
			return nextAvailable;
		}
		String shortName = n.getLocalName();
		int myOwn = nextAvailable;
		int futureAvailable = nextAvailable;

		boolean thisNodeVisible = false;
		boolean thisNodeIsReceive = false;
		// System.out.println("\nEntering toDotString on " + shortName + "
		// underReceive: " +
		// underReceive);

		String colorString = "dimgrey";

		// if (n instanceof Service){
		if (true) {
			// Service node
			if (shortName.compareTo("ws-soap")!= 0 &&
					shortName.compareTo("sc")!=0 &&
					shortName.compareTo("append") != 0 &&
					shortName.compareTo("param") != 0 &&
					shortName.compareTo("return") != 0 &&
					shortName.compareTo("no-merge") != 0){
				thisNodeVisible = true;
			}

			// send or receive?
			if (shortName.startsWith("receive") || shortName.startsWith("send")) {
				if (!underReceive) {
					colorString = "forestgreen";
				}
				sb.append(nextAvailable + " [label=\"" + shortName
						+ "\" color=\"" + colorString + "\" fontcolor=\""
						+ colorString + "\" ];\n");
				if (shortName.startsWith("receive")) {
					thisNodeIsReceive = true;
					// String recvCurrentID = new String(n.getCurrNodeID()+
					// "." + n.getCurrDocID() + "." + n.getCurrPeerID());
					// //System.out.println(">>> receive: " + myOwn + " " +
					// recvCurrentID);
					// receiveNodeIDs.put(new Integer(myOwn), recvCurrentID);
				}
				if (shortName.startsWith("send")) {
					// System.out.println(">>> send: " + myOwn);
					// sendNodeIDs.put(new Integer(myOwn), "");
				}
			} else {
				// newNode?
				if (shortName.startsWith("newNode")) {
					if (!underReceive) {
						colorString = "blue3";
					}
				} else {
					if (!underReceive) {
						colorString = "red";
					}
				}
				sb.append(nextAvailable + " [label=\""
						//+ ((Service) n).serviceName + "@"
						//+ ((Service) n).executionPeer 
						+ 
						shortName + "\" color=\""
						+ colorString + "\" fontcolor=\"" + colorString
						+ "\" ];\n");
			}

			if (thisNodeVisible) {
				if (parentID >= 0) {
					sb.append(parentID + " -- " + myOwn);
					if (underReceive) {
						sb.append(" [color=\"dimgrey\"]");
					}
					sb.append(" [dir=none];\n");
				}
				futureAvailable++;
				// System.out.println("For " + shortName + " futureAvailable is
				// " + futureAvailable);
			}

			NodeList children = n.getChildNodes();
			for (int i = 0; i < children.getLength(); i++) {
				Node child = children.item(i);
				if (thisNodeVisible) {
					futureAvailable = toDotString(child, sb,
							(underReceive || thisNodeIsReceive), myOwn,
							futureAvailable);
				} else {
					futureAvailable = toDotString(child, sb,
							(underReceive || thisNodeIsReceive), parentID,
							futureAvailable);
				}
			}
		}
		return futureAvailable;

	}
}
