package fr.inria.gemo.axml.optimax.io.output;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import sun.security.x509.DistributionPoint;

import com.sun.org.apache.xerces.internal.util.NamespaceSupport;

import fr.inria.gemo.axml.optimax.Parameters;
import fr.inria.gemo.axml.optimax.PlanRepository;
import fr.inria.gemo.axml.optimax.adocument.ADNode;
import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.adocument.Service;
import fr.inria.gemo.axml.optimax.adocument.SimpleNode;
import fr.inria.gemo.axml.optimax.helping.DinstinctNumberGenerator;
import fr.inria.gemo.axml.optimax.helping.Utilities;
import fr.inria.gemo.axml.optimax.helping.NamespaceContextWrapper;
import fr.inria.gemo.axml.optimax.info.DefaultNamespaceDeclarator;
import fr.inria.gemo.axml.optimax.info.PeerInformationModule;
import fr.inria.gemo.axml.optimax.rules.Composition;

public class AxmlFileOutputModule {

	static public Document createAxmlDomFromRewrittenADocumentAndOriginalDom(ADocument rewrittenADoc, Document originalDom)
	{
		// we constaruct the Dom
		Document result = createDomFromADocAndOrigDom(rewrittenADoc, originalDom);
		// we eliminate possible currNodeId dublicates in nodes under receive sc
		searchAndChangeCurrNodeIdsUnderReceivesThatMightBeDublicates(result);
		return result;
	}
	
	static private int searchAndChangeCurrNodeIdsUnderReceivesThatMightBeDublicates(Document givenDom)
	{
		int numberOfElementsWhichNeedToBeChanged = -1;
		DinstinctNumberGenerator dinstinctNumberGeneratorInst = new DinstinctNumberGenerator();
		
		
		XPathFactory xfactory = XPathFactory.newInstance();
		XPath xPath = xfactory.newXPath();
		NamespaceSupport defaultNamespaceSupportInstance = DefaultNamespaceDeclarator.getNamespaceSupportWithDefaultNamespaces();
		xPath.setNamespaceContext( new NamespaceContextWrapper(defaultNamespaceSupportInstance));
		
		String axmlPrefix = defaultNamespaceSupportInstance.getPrefix(Parameters.axmlURI);
		String algebraPrefix = defaultNamespaceSupportInstance.getPrefix(Parameters.algebraURI);
		
		try {
			
			NodeList nodesWhoseCurrNodeIdsHaveToChange = (NodeList) xPath.evaluate("//" + algebraPrefix + ":receive/descendant::*[@" + axmlPrefix + ":id]" , givenDom.getDocumentElement(), XPathConstants.NODESET);
			numberOfElementsWhichNeedToBeChanged = nodesWhoseCurrNodeIdsHaveToChange.getLength();
			for(int i=0; i<nodesWhoseCurrNodeIdsHaveToChange.getLength(); i++)
			{
				Attr idAttr = ((Element) nodesWhoseCurrNodeIdsHaveToChange.item(i)).getAttributeNodeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), "id");
				idAttr.setNodeValue("rec" + dinstinctNumberGeneratorInst.getNumberInt());
			}
		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return numberOfElementsWhichNeedToBeChanged;
	}
	
	static public Document createDomFromADocAndOrigDom(ADocument rewrittenADoc, Document originalDom)
	{
		System.out.println("Start: createAxmlDomFromRewrittenADocumentAndOriginalDom");
		System.out.println(rewrittenADoc);
		
		System.out.println("rewrittenADoc.newServiceCurrNodeIdsToOld: " + rewrittenADoc.newScCurrNodeIdsToOld);
		System.out.println("rewrittenADoc.oldServiceCurrNodeIdsToNew: " + rewrittenADoc.oldScCurrNodeIdsToNew);
		
		LinkedList<Service> scsThatMightNeedUpdateAtTheirExecutionPeer = new LinkedList<Service>();
		Map<Service,Node> mapOfScsThatMightNeedUpdateAtTheirExecutionPeer = new HashMap<Service,Node>();
		
//		VerboseADocumentDrawingModule.createOutputImage(rewrittenADoc, "axmlFileOutPut");
		
		XPathFactory xfactory = XPathFactory.newInstance();
		XPath xPath = xfactory.newXPath();
		NamespaceSupport defaultNamespaceSupportInstance = DefaultNamespaceDeclarator.getNamespaceSupportWithDefaultNamespaces();
		
		xPath.setNamespaceContext( new NamespaceContextWrapper(defaultNamespaceSupportInstance));
		
		Map<String,LinkedList<Node>> aDocNodesToAxmlDomNodesMap = new HashMap<String,LinkedList<Node>>();
		
		Document rewrittenDom = null;
		DocumentBuilderFactory dfactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder loader;
		try {
			loader = dfactory.newDocumentBuilder();
			rewrittenDom = loader.newDocument();
			
			ADNode rootOfRewrittenADoc = rewrittenADoc.getRootOfADoc();
			LinkedList<ADNode> aDNodesToBeVisited = new LinkedList<ADNode>();
			aDNodesToBeVisited.add(rootOfRewrittenADoc);
			PeerInformationModule peerInformationModuleInstance = PeerInformationModule.getInstance();

			String axmlPrefix = defaultNamespaceSupportInstance.getPrefix(Parameters.axmlURI);
			String algebraPrefix = defaultNamespaceSupportInstance.getPrefix(Parameters.algebraURI);
			String queryPrefix = defaultNamespaceSupportInstance.getPrefix(Parameters.queryURI);
			
			while(!aDNodesToBeVisited.isEmpty())
			{
				ADNode currADNode = aDNodesToBeVisited.removeFirst();
				
				
				System.err.println("=======================");
				
				if(currADNode instanceof Service)
				{
					System.err.println("Service:");
					System.err.println(((Service)currADNode).getServiceName());
					System.err.println("X:" + ((Service)currADNode).getXPath());
					Service currServNode = (Service)currADNode;
					if(currServNode.getServiceName().toString().equals("send") || currServNode.getServiceName().toString().equals("receive"))
					{
//						Service serviceUnderRec = (Service)currServNode.getChildren().get(0);
//						System.err.println("lala" + serviceUnderRec.getXPath());
					}
				}
				else
				{
					System.err.println("SimpleNode:");
					System.err.println(((SimpleNode)currADNode).getNodeData());
					System.err.println("X list:" + ((SimpleNode)currADNode).getXPathList().size());
				}
				
				System.err.println(currADNode.getCurrNodeID());
				System.err.println(currADNode.getCurrDocID());
				System.err.println(currADNode.getCurrPeerID());
				System.err.println(currADNode.getOrigNodeID());
				System.err.println(currADNode.getOrigDocID());
				System.err.println(currADNode.getOrigPeerID());
				System.err.println("=======================");
				
				
				
				if(currADNode instanceof SimpleNode)
				{
					SimpleNode currSimpleNode = (SimpleNode) currADNode;
					LinkedList<Node> domNodesRelatedToCurrSimpleNode = new LinkedList<Node>();
					
//					// if it is a param node we skip it
//					if(currSimpleNode.getNodeData().toString().equals(new String(queryPrefix + ":param")))
//					{
//						aDocNodesToAxmlDomNodesMap.put(currSimpleNode.getCurrNodeID().toString(), domNodesRelatedToCurrSimpleNode);
//					}
//					// if it is a declaration node
					if(currSimpleNode.getNodeData().toString().equals(new String(queryPrefix + ":declaration")))
					{
						Element tempDeclarationNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(queryPrefix), new String(queryPrefix + ":" + "declaration"));

						NodeList childrenOfDeclar = currSimpleNode.declaration.getDocumentElement().getChildNodes();
						for(int i=0; i<childrenOfDeclar.getLength(); i++)
						{
							Node importedNode = rewrittenDom.importNode(childrenOfDeclar.item(i), true);
							tempDeclarationNodeForRewrittenDom.appendChild(importedNode);
						}
						
						domNodesRelatedToCurrSimpleNode.add(tempDeclarationNodeForRewrittenDom);
						aDocNodesToAxmlDomNodesMap.put(currSimpleNode.getCurrNodeID().toString(), domNodesRelatedToCurrSimpleNode);
					}
					// if the xpath list is not empty then this node was not created
					// during optimization
					else if(!currSimpleNode.getXPathList().isEmpty())
					{
						for(int i = 0; i < currSimpleNode.getXPathList().size(); i++)
						{
							Node tempNodeAtOriginalDom = (Node) xPath.evaluate(currSimpleNode.getXPathList().get(i).toString() , originalDom.getDocumentElement(), XPathConstants.NODE);
							Node tempNodeForRewrittenDom;
							if(currSimpleNode.getChildren().isEmpty())
								tempNodeForRewrittenDom = rewrittenDom.importNode(tempNodeAtOriginalDom, true);
							else
								tempNodeForRewrittenDom = rewrittenDom.importNode(tempNodeAtOriginalDom, false);
							
							if(currSimpleNode.getXPathList().size() == 1)
							{
								Attr currNodeIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":id") , tempNodeForRewrittenDom, XPathConstants.NODE);
								if(currNodeIdAttr != null)
									currNodeIdAttr.setNodeValue(currSimpleNode.getCurrNodeID().toString());
								
								Attr origNodeIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":nodeID") , tempNodeForRewrittenDom, XPathConstants.NODE);
								if(origNodeIdAttr != null)
									origNodeIdAttr.setNodeValue(currSimpleNode.getOrigNodeID().toString());
								
								Attr origDocIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":docID") , tempNodeForRewrittenDom, XPathConstants.NODE);
								if(origDocIdAttr != null)
									origDocIdAttr.setNodeValue(currSimpleNode.getOrigDocID().toString());
	
								Attr origPeerIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":peerID") , tempNodeForRewrittenDom, XPathConstants.NODE);
								if(origPeerIdAttr != null)
									origPeerIdAttr.setNodeValue(currSimpleNode.getOrigPeerID().toString());
							}
							
							domNodesRelatedToCurrSimpleNode.add(tempNodeForRewrittenDom);
						}
						aDocNodesToAxmlDomNodesMap.put(currSimpleNode.getCurrNodeID().toString(), domNodesRelatedToCurrSimpleNode);
					}
					// if it is empty then it was created during optimization and we must
					// create a dom node from scratch
					else
					{
//						System.out.println("xaxaxa-------->>>" + currSimpleNode.getNodeData().toString());
//						System.out.println("xaxaxa-------->>>" + currSimpleNode);
//						System.out.println("xaxaxa-------->>>" + currSimpleNode.getNodeID());
//						System.out.println("xaxaxa-------->>>" + currSimpleNode.getNodeDataNotUsedInEqualFunction());
						
						String elementName = new String();
						elementName.concat(currSimpleNode.getNodeData().toString());
						// if length is 0 and !currSimpleNode.getXPathList().isEmpty() then it is either the destination address
						// of the send or the receiving address of the receive either a data pointer of send. If it is address
						// it does not have to represented with a node at this part of a document (it is included at another part).
						// If it is a data pointer, it has to be represented with a node
						if(elementName.length() == 0 && !currSimpleNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
						{
							// if it not the last child of its father then it is a data pointer. The addresses of send, receive and newNode
							// are always the last child
							ADNode lastButOneChildOfTheFatherOfTheCurrSimpleNode = currSimpleNode.getFather().getChildren().get(currSimpleNode.getFather().getChildren().size()-2);
							if(lastButOneChildOfTheFatherOfTheCurrSimpleNode instanceof SimpleNode)
							{
								SimpleNode simpleNodeLastButOneChildOfTheFatherOfTheCurrSimpleNode = (SimpleNode) lastButOneChildOfTheFatherOfTheCurrSimpleNode;
								if(simpleNodeLastButOneChildOfTheFatherOfTheCurrSimpleNode.equals(currSimpleNode))
									if(simpleNodeLastButOneChildOfTheFatherOfTheCurrSimpleNode.getRemoteOriginalIdAndHostingPeer().equals(currSimpleNode.getRemoteOriginalIdAndHostingPeer()))
									{
										Element tempAlgebraCurrentIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":originalID"));
										
										Element tempAlgebraOrPeerIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":peerID"));
										tempAlgebraCurrentIdNodeForRewrittenDom.appendChild(tempAlgebraOrPeerIdNodeForRewrittenDom);
										Text tempAlgebraOrPeerIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(currSimpleNode.getRemoteOriginalIdAndHostingPeer().id.peerID);
										tempAlgebraOrPeerIdNodeForRewrittenDom.appendChild(tempAlgebraOrPeerIdTextNodeForRewrittenDom);
										Element tempAlgebraOrDocIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":docID"));
										tempAlgebraCurrentIdNodeForRewrittenDom.appendChild(tempAlgebraOrDocIdNodeForRewrittenDom);
										Text tempAlgebraOrDocIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(currSimpleNode.getRemoteOriginalIdAndHostingPeer().id.docID);
										tempAlgebraOrDocIdNodeForRewrittenDom.appendChild(tempAlgebraOrDocIdTextNodeForRewrittenDom);
										Element tempAlgebraOrNodeIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":nodeID"));
										tempAlgebraCurrentIdNodeForRewrittenDom.appendChild(tempAlgebraOrNodeIdNodeForRewrittenDom);
										Text tempAlgebraOrNodeIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(currSimpleNode.getRemoteOriginalIdAndHostingPeer().id.nodeID);
										tempAlgebraOrNodeIdNodeForRewrittenDom.appendChild(tempAlgebraOrNodeIdTextNodeForRewrittenDom);
										
										domNodesRelatedToCurrSimpleNode.add(tempAlgebraCurrentIdNodeForRewrittenDom);
										aDocNodesToAxmlDomNodesMap.put(currSimpleNode.getCurrNodeID().toString(), domNodesRelatedToCurrSimpleNode);
									}
							}
						}
						else
						{
							Element tempNodeForRewrittenDom = rewrittenDom.createElement(elementName);
							domNodesRelatedToCurrSimpleNode.add(tempNodeForRewrittenDom);
							aDocNodesToAxmlDomNodesMap.put(currSimpleNode.getCurrNodeID().toString(), domNodesRelatedToCurrSimpleNode);
						}
					}
				}
				
				if(currADNode instanceof Service)
				{
					Service currService = (Service) currADNode;
					LinkedList<Node> domNodesRelatedToCurrService = new LinkedList<Node>();
					if(currService.getXPath() != null && currService.getXPath().length() != 0)
					{
						Node tempNodeAtOriginalDom = (Node) xPath.evaluate(currService.getXPath().toString() , originalDom.getDocumentElement(), XPathConstants.NODE);
						Node tempNodeForRewrittenDom = rewrittenDom.importNode(tempNodeAtOriginalDom, false);

						Node tempReturnNodeAtOriginalDom = (Node) xPath.evaluate(new String(axmlPrefix + ":return") , tempNodeAtOriginalDom, XPathConstants.NODE);
						if(tempReturnNodeAtOriginalDom != null)
						{
							Node tempReturnNodeForRewrittenDom = rewrittenDom.importNode(tempReturnNodeAtOriginalDom, true);
							tempNodeForRewrittenDom.appendChild(tempReturnNodeForRewrittenDom);
						}
						
						Attr currNodeIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":id") , tempNodeForRewrittenDom, XPathConstants.NODE);
						if(currNodeIdAttr != null)
						{
							String currIdInTheGivenAXMLDoc = rewrittenADoc.newScCurrNodeIdsToOld.get(currService.getCurrNodeID().toString());
							if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
								currIdInTheGivenAXMLDoc = currService.getCurrNodeID().toString();
							currNodeIdAttr.setNodeValue(currIdInTheGivenAXMLDoc);
						}
						
						Attr origNodeIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":nodeID") , tempNodeForRewrittenDom, XPathConstants.NODE);
						if(origNodeIdAttr != null)
							origNodeIdAttr.setNodeValue(currService.getOrigNodeID().toString());
						else
						{
							origNodeIdAttr = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":nodeID"));
							origNodeIdAttr.setValue(currService.getOrigNodeID().toString());
							((Element)tempNodeForRewrittenDom).setAttributeNode(origNodeIdAttr);
						}
						
						Attr origDocIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":docID") , tempNodeForRewrittenDom, XPathConstants.NODE);
						if(origDocIdAttr != null)
							origDocIdAttr.setNodeValue(currService.getOrigDocID().toString());
						else
						{
							origDocIdAttr = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":docID"));
							origDocIdAttr.setValue(currService.getOrigDocID().toString());
							((Element)tempNodeForRewrittenDom).setAttributeNode(origDocIdAttr);
						}
						
						Attr origPeerIdAttr = (Attr) xPath.evaluate(new String("@" + axmlPrefix + ":peerID") , tempNodeForRewrittenDom, XPathConstants.NODE);
						if(origPeerIdAttr != null)
							origPeerIdAttr.setNodeValue(currService.getOrigPeerID().toString());
						else
						{
							origPeerIdAttr = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":peerID"));
							origPeerIdAttr.setValue(currService.getOrigPeerID().toString());
							((Element)tempNodeForRewrittenDom).setAttributeNode(origPeerIdAttr);
						}
						
						if(currService.serviceName.toString().equals(Parameters.GQS) || currService.serviceName.toString().equals(Parameters.STS))
						{
							scsThatMightNeedUpdateAtTheirExecutionPeer.add(currService);
							mapOfScsThatMightNeedUpdateAtTheirExecutionPeer.put(currService, tempNodeForRewrittenDom);
						}
						
						domNodesRelatedToCurrService.add(tempNodeForRewrittenDom);
						aDocNodesToAxmlDomNodesMap.put(currService.getCurrNodeID().toString(), domNodesRelatedToCurrService);
					}
					else
					{
						// In the beggining we add the service call tag
						Element tempScNodeForRewrittenDom = rewrittenDom.createElement(new String(axmlPrefix + ":sc"));
						
						if(currService.getServiceName().toString().equals("send"))
						{
							Attr tempIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":id"));
							tempIDNodeForRewrittenDom.setValue(currService.getCurrNodeID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempIDNodeForRewrittenDom);

							Attr tempOriginalNodeIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":nodeID"));
							tempOriginalNodeIDNodeForRewrittenDom.setValue(currService.getOrigNodeID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalNodeIDNodeForRewrittenDom);

							Attr tempOriginalDocIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":docID"));
							tempOriginalDocIDNodeForRewrittenDom.setValue(currService.getOrigDocID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalDocIDNodeForRewrittenDom);

							Attr tempOriginalPeerIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":peerID"));
							tempOriginalPeerIDNodeForRewrittenDom.setValue(currService.getOrigPeerID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalPeerIDNodeForRewrittenDom);

							Element tempActivationNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":activation"));
							tempScNodeForRewrittenDom.appendChild(tempActivationNodeForRewrittenDom);
							
							Element tempReturnNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":return"));
							tempScNodeForRewrittenDom.appendChild(tempReturnNodeForRewrittenDom);
							Attr materializerForSendForRewrittenDom = rewrittenDom.createAttribute("materializer");
							materializerForSendForRewrittenDom.setValue(Parameters.materializerForSendURI);
							tempReturnNodeForRewrittenDom.setAttributeNode(materializerForSendForRewrittenDom);
							
							Element voidNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":void"));
							tempScNodeForRewrittenDom.appendChild(tempActivationNodeForRewrittenDom);
							tempReturnNodeForRewrittenDom.appendChild(voidNodeForRewrittenDom);
							
							if(currService.getAfterActivated().size() > 0)
							{
								Iterator<String> afterActivatedIter = currService.getAfterActivated().iterator();
								while(afterActivatedIter.hasNext())
								{
									String currAfterActivated = afterActivatedIter.next();
									Element tempAfterActivatedNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":afterActivated"));
									tempActivationNodeForRewrittenDom.appendChild(tempAfterActivatedNodeForRewrittenDom);
									
									Attr tempAfterActivatedAttrNodeForRewrittenDom = rewrittenDom.createAttribute(new String("sc"));
									String currIdInTheGivenAXMLDoc = rewrittenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
									if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
										currIdInTheGivenAXMLDoc = currAfterActivated;
									tempAfterActivatedAttrNodeForRewrittenDom.setValue(currIdInTheGivenAXMLDoc);
									tempAfterActivatedNodeForRewrittenDom.setAttributeNode(tempAfterActivatedAttrNodeForRewrittenDom);
								}
							}
							
							if(currService.getAfterTerminated().size() > 0)
							{
								Iterator<String> afterTerminatedIter = currService.getAfterTerminated().iterator();
								while(afterTerminatedIter.hasNext())
								{
									String currAfterTerminated = afterTerminatedIter.next();
									Element tempAfterTerminatedNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":afterTerminated"));
									tempActivationNodeForRewrittenDom.appendChild(tempAfterTerminatedNodeForRewrittenDom);
									
									Attr tempAfterTerminatedAttrNodeForRewrittenDom = rewrittenDom.createAttribute(new String("sc"));
									String currIdInTheGivenAXMLDoc = rewrittenADoc.newScCurrNodeIdsToOld.get(currAfterTerminated);
									if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
										currIdInTheGivenAXMLDoc = currAfterTerminated;
									tempAfterTerminatedAttrNodeForRewrittenDom.setValue(currIdInTheGivenAXMLDoc);
									tempAfterTerminatedNodeForRewrittenDom.setAttributeNode(tempAfterTerminatedAttrNodeForRewrittenDom);
								}
							}
							
							Element tempWsSoapNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":ws-soap"));
							tempScNodeForRewrittenDom.appendChild(tempWsSoapNodeForRewrittenDom);
							Attr tempEndPointNodeForRewrittenDom = rewrittenDom.createAttribute("endpoint");
							tempEndPointNodeForRewrittenDom.setValue(peerInformationModuleInstance.getEndPoint(currService.getExecutionPeer().toString(), "send"));
							tempWsSoapNodeForRewrittenDom.setAttributeNode(tempEndPointNodeForRewrittenDom);
							
							Element tempAlgebraSendNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":send"));
							tempWsSoapNodeForRewrittenDom.appendChild(tempAlgebraSendNodeForRewrittenDom);
							
							Element tempAlgebraAddressNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":address"));
							tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraAddressNodeForRewrittenDom);
							
							SimpleNode addressContainingSimpleNode = (SimpleNode) currService.getChildren().get(currService.getChildren().size()-1);
							Element tempAlgebraOriginalIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":originalID"));
							tempAlgebraAddressNodeForRewrittenDom.appendChild(tempAlgebraOriginalIdNodeForRewrittenDom);
							Element tempAlgebraOrPeerIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":peerID"));
							tempAlgebraOriginalIdNodeForRewrittenDom.appendChild(tempAlgebraOrPeerIdNodeForRewrittenDom);
							Text tempAlgebraOrPeerIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().id.peerID);
							tempAlgebraOrPeerIdNodeForRewrittenDom.appendChild(tempAlgebraOrPeerIdTextNodeForRewrittenDom);
							Element tempAlgebraOrDocIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":docID"));
							tempAlgebraOriginalIdNodeForRewrittenDom.appendChild(tempAlgebraOrDocIdNodeForRewrittenDom);
							Text tempAlgebraOrDocIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().id.docID);
							tempAlgebraOrDocIdNodeForRewrittenDom.appendChild(tempAlgebraOrDocIdTextNodeForRewrittenDom);
							Element tempAlgebraOrNodeIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":nodeID"));
							tempAlgebraOriginalIdNodeForRewrittenDom.appendChild(tempAlgebraOrNodeIdNodeForRewrittenDom);
//							String origIdInTheGivenAXMLDoc = rewrittenADoc.newServiceCurrNodeIdsToOld.get(addressContainingSimpleNode.getRemoteOrigNodeIdOrigDocIdOrigPeerIdHostPeerContainer().get(0).toString());
//							if(origIdInTheGivenAXMLDoc == null || origIdInTheGivenAXMLDoc.length() == 0)
							String origIdInTheGivenAXMLDoc = addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().id.nodeID;
							Text tempAlgebraOrNodeIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(origIdInTheGivenAXMLDoc);
							tempAlgebraOrNodeIdNodeForRewrittenDom.appendChild(tempAlgebraOrNodeIdTextNodeForRewrittenDom);
						
							Element tempAlgebraEndPointNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":endpoint"));
							tempAlgebraAddressNodeForRewrittenDom.appendChild(tempAlgebraEndPointNodeForRewrittenDom);
							Text tempAlgebraEndPointTextNodeForRewrittenDom = rewrittenDom.createTextNode(peerInformationModuleInstance.getEndPoint(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().host, "receive"));
							tempAlgebraEndPointNodeForRewrittenDom.appendChild(tempAlgebraEndPointTextNodeForRewrittenDom);
//							System.out.println("--------------------->>>  " + peerInformationModuleInstance.getEndPoint(addressContainingSimpleNode.getNodeIdAndPeerIdContainer().get(1).toString(), "send"));
//							System.out.println("--------------------->>>  " + addressContainingSimpleNode.getNodeIdAndPeerIdContainer().get(1).toString());

							ADNode lastButOneChild = currService.getChildren().get(currService.getChildren().size() - 2);
							// if the last but one child is a reference then this send uses only references to point to the data
							// that are going to be sent
							if(lastButOneChild instanceof SimpleNode && ((SimpleNode)lastButOneChild).getNodeData().length() == 0)
							{
								Element tempAlgebraReferenceNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":reference"));
								tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraReferenceNodeForRewrittenDom);	
							}
							else
							{
								Element tempAlgebraDataNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":data"));
								tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraDataNodeForRewrittenDom);
							}
							
						}
						else if(currService.getServiceName().toString().equals("receive"))
						{
							Attr tempIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":id"));
							String currIdInTheGivenAXMLDoc = rewrittenADoc.newScCurrNodeIdsToOld.get(currService.getCurrNodeID().toString());
							if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
								currIdInTheGivenAXMLDoc = currService.getCurrNodeID().toString();
							tempIDNodeForRewrittenDom.setValue(currIdInTheGivenAXMLDoc);
							tempScNodeForRewrittenDom.setAttributeNode(tempIDNodeForRewrittenDom);
							
							Attr tempOriginalNodeIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":nodeID"));
//							tempOriginalNodeIDNodeForRewrittenDom.setValue(currIdInTheGivenAXMLDoc);
							tempOriginalNodeIDNodeForRewrittenDom.setValue(currService.getOrigNodeID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalNodeIDNodeForRewrittenDom);

							Attr tempOriginalDocIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":docID"));
							tempOriginalDocIDNodeForRewrittenDom.setValue(currService.getOrigDocID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalDocIDNodeForRewrittenDom);

							Attr tempOriginalPeerIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":peerID"));
							tempOriginalPeerIDNodeForRewrittenDom.setValue(currService.getOrigPeerID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalPeerIDNodeForRewrittenDom);
							
							Element tempReturnNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":return"));
							tempScNodeForRewrittenDom.appendChild(tempReturnNodeForRewrittenDom);
							
							Attr materializerForReceiveForRewrittenDom = rewrittenDom.createAttribute("materializer");
							materializerForReceiveForRewrittenDom.setValue(Parameters.materializerForReceiveURI);
							tempReturnNodeForRewrittenDom.setAttributeNode(materializerForReceiveForRewrittenDom);
							
							Element tempAppendNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":append"));
							tempReturnNodeForRewrittenDom.appendChild(tempAppendNodeForRewrittenDom);
							
							Element tempWsSoapNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":ws-soap"));
							tempScNodeForRewrittenDom.appendChild(tempWsSoapNodeForRewrittenDom);
							Attr tempEndPointNodeForRewrittenDom = rewrittenDom.createAttribute("endpoint");
							tempEndPointNodeForRewrittenDom.setValue(peerInformationModuleInstance.getEndPoint(currService.getExecutionPeer().toString(), "receive"));
							tempWsSoapNodeForRewrittenDom.setAttributeNode(tempEndPointNodeForRewrittenDom);

							Element tempAlgebraSendNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":receive"));
							tempWsSoapNodeForRewrittenDom.appendChild(tempAlgebraSendNodeForRewrittenDom);
							
							Element tempAlgebraAddressNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":address"));
							tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraAddressNodeForRewrittenDom);
							
							SimpleNode addressContainingSimpleNode = (SimpleNode) currService.getChildren().get(currService.getChildren().size()-1);
							Element tempAlgebraOriginalIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":originalID"));
							tempAlgebraAddressNodeForRewrittenDom.appendChild(tempAlgebraOriginalIdNodeForRewrittenDom);
							Element tempAlgebraOrPeerIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":peerID"));
							tempAlgebraOriginalIdNodeForRewrittenDom.appendChild(tempAlgebraOrPeerIdNodeForRewrittenDom);
							Text tempAlgebraOrPeerIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().id.peerID);
							tempAlgebraOrPeerIdNodeForRewrittenDom.appendChild(tempAlgebraOrPeerIdTextNodeForRewrittenDom);
							Element tempAlgebraOrDocIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":docID"));
							tempAlgebraOriginalIdNodeForRewrittenDom.appendChild(tempAlgebraOrDocIdNodeForRewrittenDom);
							Text tempAlgebraOrDocIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().id.docID);
							tempAlgebraOrDocIdNodeForRewrittenDom.appendChild(tempAlgebraOrDocIdTextNodeForRewrittenDom);
							Element tempAlgebraOrNodeIdNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":nodeID"));
							tempAlgebraOriginalIdNodeForRewrittenDom.appendChild(tempAlgebraOrNodeIdNodeForRewrittenDom);
							Text tempAlgebraOrNodeIdTextNodeForRewrittenDom = rewrittenDom.createTextNode(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().id.nodeID);
							tempAlgebraOrNodeIdNodeForRewrittenDom.appendChild(tempAlgebraOrNodeIdTextNodeForRewrittenDom);
							
							Element tempAlgebraEndPointNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":endpoint"));
							tempAlgebraAddressNodeForRewrittenDom.appendChild(tempAlgebraEndPointNodeForRewrittenDom);
							Text tempAlgebraEndPointTextNodeForRewrittenDom = rewrittenDom.createTextNode(peerInformationModuleInstance.getEndPoint(addressContainingSimpleNode.getRemoteOriginalIdAndHostingPeer().host, "send"));
							tempAlgebraEndPointNodeForRewrittenDom.appendChild(tempAlgebraEndPointTextNodeForRewrittenDom);
							
							ADNode lastButOneChild = currService.getChildren().get(currService.getChildren().size() - 2);
							// if the last but one child is a reference then this send uses only references to point to the data
							// that are going to be sent
							if(lastButOneChild instanceof SimpleNode && ((SimpleNode)lastButOneChild).getNodeData().length() == 0)
							{
								Element tempAlgebraReferenceNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":reference"));
								tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraReferenceNodeForRewrittenDom);	
							}
							else
							{
								Element tempAlgebraDataNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":data"));
								tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraDataNodeForRewrittenDom);
							}
						}
						
						else if(currService.getServiceName().toString().equals("newNode"))
						{
							Attr tempIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":id"));
							tempIDNodeForRewrittenDom.setValue(currService.getCurrNodeID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempIDNodeForRewrittenDom);

							Attr tempOriginalNodeIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":nodeID"));
							tempOriginalNodeIDNodeForRewrittenDom.setValue(currService.getOrigNodeID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalNodeIDNodeForRewrittenDom);

							Attr tempOriginalDocIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":docID"));
							tempOriginalDocIDNodeForRewrittenDom.setValue(currService.getOrigDocID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalDocIDNodeForRewrittenDom);

							Attr tempOriginalPeerIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":peerID"));
							tempOriginalPeerIDNodeForRewrittenDom.setValue(currService.getOrigPeerID().toString());
							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalPeerIDNodeForRewrittenDom);

							Element tempReturnNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":return"));
							tempScNodeForRewrittenDom.appendChild(tempReturnNodeForRewrittenDom);
							Element tempAppendNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":no-merge"));
							tempReturnNodeForRewrittenDom.appendChild(tempAppendNodeForRewrittenDom);
							
							Element tempWsSoapNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":ws-soap"));
							tempScNodeForRewrittenDom.appendChild(tempWsSoapNodeForRewrittenDom);
							Attr tempEndPointNodeForRewrittenDom = rewrittenDom.createAttribute("endpoint");
							tempEndPointNodeForRewrittenDom.setValue(peerInformationModuleInstance.getEndPoint(currService.getExecutionPeer().toString(), "newNode"));
							tempWsSoapNodeForRewrittenDom.setAttributeNode(tempEndPointNodeForRewrittenDom);
							
							Element tempAlgebraSendNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":newNode"));
							tempWsSoapNodeForRewrittenDom.appendChild(tempAlgebraSendNodeForRewrittenDom);
							Element tempAlgebraAddressNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":address"));
							tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraAddressNodeForRewrittenDom);

							Element tempAlgebraDataNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(algebraPrefix), new String(algebraPrefix + ":data"));
							tempAlgebraSendNodeForRewrittenDom.appendChild(tempAlgebraDataNodeForRewrittenDom);
						}
//						else if(currService.getServiceName().toString().equals(Parameters.GQS))
//						{
//							System.out.println(currService.getServiceName().toString().equals(Parameters.GQS));
//							System.out.println(currService);
//							System.out.println("-----------------");
//							
//							Attr tempIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":id"));
//							String currIdInTheGivenAXMLDoc = rewrittenADoc.newServiceCurrNodeIdsToOld.get(currService.getCurrNodeID().toString());
//							if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
//								currIdInTheGivenAXMLDoc = currService.getCurrNodeID().toString();
//							tempIDNodeForRewrittenDom.setValue(currIdInTheGivenAXMLDoc);
//							tempScNodeForRewrittenDom.setAttributeNode(tempIDNodeForRewrittenDom);
//							
//							Attr tempOriginalNodeIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":nodeID"));
////							tempOriginalNodeIDNodeForRewrittenDom.setValue(currIdInTheGivenAXMLDoc);
//							tempOriginalNodeIDNodeForRewrittenDom.setValue(currService.getOrigNodeID().toString());
//							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalNodeIDNodeForRewrittenDom);
//
//							Attr tempOriginalDocIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":docID"));
//							tempOriginalDocIDNodeForRewrittenDom.setValue(currService.getOrigDocID().toString());
//							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalDocIDNodeForRewrittenDom);
//
//							Attr tempOriginalPeerIDNodeForRewrittenDom = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":peerID"));
//							tempOriginalPeerIDNodeForRewrittenDom.setValue(currService.getOrigPeerID().toString());
//							tempScNodeForRewrittenDom.setAttributeNode(tempOriginalPeerIDNodeForRewrittenDom);
//							
//							Element tempReturnNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":return"));
//							tempScNodeForRewrittenDom.appendChild(tempReturnNodeForRewrittenDom);
//							
//							Attr receiveMaterializer = rewrittenDom.createAttributeNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String("materializer"));
//							receiveMaterializer.setValue(Parameters.materializerURI);
//							tempReturnNodeForRewrittenDom.setAttributeNode(receiveMaterializer);
//							
//							Element tempAppendNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":append"));
//							tempReturnNodeForRewrittenDom.appendChild(tempAppendNodeForRewrittenDom);
//							
//							Element tempWsSoapNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(axmlPrefix), new String(axmlPrefix + ":ws-soap"));
//							tempScNodeForRewrittenDom.appendChild(tempWsSoapNodeForRewrittenDom);
//							Attr tempEndPointNodeForRewrittenDom = rewrittenDom.createAttribute("endpoint");
//							tempEndPointNodeForRewrittenDom.setValue(peerInformationModuleInstance.getEndPoint(currService.getExecutionPeer().toString(), Parameters.GQS));
//							tempWsSoapNodeForRewrittenDom.setAttributeNode(tempEndPointNodeForRewrittenDom);
//
//							Element tempContinuousQueryNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(queryPrefix), new String(queryPrefix + ":" + "continuousQuery"));
//							tempWsSoapNodeForRewrittenDom.appendChild(tempContinuousQueryNodeForRewrittenDom);
//
//							Element tempDeclarationNodeForRewrittenDom = rewrittenDom.createElementNS(defaultNamespaceSupportInstance.getURI(queryPrefix), new String(queryPrefix + ":" + "declaration"));
//							tempContinuousQueryNodeForRewrittenDom.appendChild(tempDeclarationNodeForRewrittenDom);
//
//							// we are going to add as a child of tempDeclarationNodeForRewrittenDom the declaration of the GQS call
//							// first we locate it in the ADOC
//							SimpleNode declarationContainer = null;
//							Composition compInstance = new Composition();
//							SimpleNode continuousQuerySN = (SimpleNode) compInstance.checkIfItIsContGQS(currService);
//							if(continuousQuerySN == null)
//							{
//								System.err.println("Error at AxmlFileOutputModule");
//								System.exit(0);
//							}
//							for(int i=0; i<continuousQuerySN.getChildren().size(); i++)
//							{
//								if(continuousQuerySN.getChildren().get(i) instanceof SimpleNode)
//								{
//									SimpleNode continuousQueryChildSN = (SimpleNode) continuousQuerySN.getChildren().get(i);
//									if(continuousQueryChildSN.getNodeData().toString().equals(new String(queryPrefix + ":declaration")))
//									{
//										declarationContainer = continuousQueryChildSN;
//									}
//								}
//							}
//							
//							System.out.println("declarationContainer");
//							System.out.println(declarationContainer);
//							
//							NodeList childrenOfDeclar = declarationContainer.declaration.getDocumentElement().getChildNodes();
//							for(int i=0; i<childrenOfDeclar.getLength(); i++)
//							{
//								Node importedNode = rewrittenDom.importNode(childrenOfDeclar.item(i), true);
//								tempDeclarationNodeForRewrittenDom.appendChild(importedNode);
//							}
//						}
						
						domNodesRelatedToCurrService.add(tempScNodeForRewrittenDom);
						aDocNodesToAxmlDomNodesMap.put(currService.getCurrNodeID().toString(), domNodesRelatedToCurrService);
					}
					
				}
				
				if(!currADNode.getChildren().isEmpty())
					aDNodesToBeVisited.addAll(currADNode.getChildren());
			}
			
			// Second loop
			aDNodesToBeVisited.add(rootOfRewrittenADoc);
			while(!aDNodesToBeVisited.isEmpty())
			{
				ADNode currADNode = aDNodesToBeVisited.removeFirst();

				LinkedList<Node> domNodesRelatedToCurrADNode = aDocNodesToAxmlDomNodesMap.get(currADNode.getCurrNodeID().toString());
				if(domNodesRelatedToCurrADNode == null)
					continue;
				// we will skip tha q:param nodes which are in q:declaration
				if(currADNode instanceof SimpleNode)
				{
					SimpleNode simpleCurrADNode = (SimpleNode)currADNode;
					if(simpleCurrADNode.getNodeData().toString().equals(new String(queryPrefix + ":param")))
					{
						if(simpleCurrADNode.getFather() instanceof SimpleNode)
						{
							SimpleNode father = (SimpleNode) simpleCurrADNode.getFather();
							if(father.getNodeData().toString().equals(new String(queryPrefix + ":declaration")))
								continue;
						}
					}
				}
				// if currADNode is not the root of the ADocument
				if(currADNode != rootOfRewrittenADoc)
				{
					ADNode fatherOfCurrADNode = currADNode.getFather();
					// This list will always contain one dom node (it is not a grouping SimpleNode),
					// so we know who is the father of the nodes that are in domNodesRelatedToCurrADNode list
					LinkedList<Node> domNodeRelatedToParentOfCurrADNode = aDocNodesToAxmlDomNodesMap.get(fatherOfCurrADNode.getCurrNodeID().toString());
					
					Node domFather  = domNodeRelatedToParentOfCurrADNode.getFirst();
					if(fatherOfCurrADNode instanceof Service)
					{
						Service serviceFatherOfCurrADNode = (Service) fatherOfCurrADNode;
						StringBuffer servName = serviceFatherOfCurrADNode.getServiceName();
						if(servName.toString().equals("newNode"))
						{
							domFather = (Node) xPath.evaluate(new String("*//" + algebraPrefix + ":data") , domFather, XPathConstants.NODE);
						}
						if(servName.toString().equals("send") || servName.toString().equals("receive"))
						{
							// if it a reference
							if(currADNode instanceof SimpleNode && ((SimpleNode)currADNode).getNodeData().length() == 0)
								domFather = (Node) xPath.evaluate(new String("*//" + algebraPrefix + ":reference") , domFather, XPathConstants.NODE);
							// if it is the actual data
							else
								domFather = (Node) xPath.evaluate(new String("*//" + algebraPrefix + ":data") , domFather, XPathConstants.NODE);
						}
					}
					for(int i=0; i<domNodesRelatedToCurrADNode.size(); i++)
					{
//						if(fatherOfCurrADNode instanceof Service && ((Service)fatherOfCurrADNode).getServiceName().toString().equals("send"));
//						else
							domFather.appendChild(domNodesRelatedToCurrADNode.get(i));
					}
				}
				else
					rewrittenDom.appendChild(domNodesRelatedToCurrADNode.getFirst());
				
				if(!currADNode.getChildren().isEmpty())
					aDNodesToBeVisited.addAll(currADNode.getChildren());
			}
			
			Iterator<Service> nodeIter = scsThatMightNeedUpdateAtTheirExecutionPeer.iterator();		
			{
				Service currService = nodeIter.next();
				Node respScNode = mapOfScsThatMightNeedUpdateAtTheirExecutionPeer.get(currService);
				
				Node wsSoapRestNode = null;
				
				Node wssoapNode = (Node) xPath.evaluate(new String(axmlPrefix + ":ws-soap") , respScNode, XPathConstants.NODE);
				if(wssoapNode != null)
					wsSoapRestNode = wssoapNode;
			
				Node wsRestNode = (Node) xPath.evaluate(new String(axmlPrefix + ":ws-rest") , respScNode, XPathConstants.NODE);
				if(wsRestNode != null)
					wsSoapRestNode = wsRestNode;
				
				Attr endPoint = (Attr) xPath.evaluate("@endpoint" , wsSoapRestNode, XPathConstants.NODE);
				endPoint.setNodeValue(peerInformationModuleInstance.getEndPoint(currService.getExecutionPeer().toString(), currService.getServiceName().toString()));
			}
			
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return rewrittenDom;
	}
	
	public static void createAxmlFileFromRewrittenADocumentAndOriginalDom(ADocument rewrittenADoc, Document originalDom, StringBuffer fileName)
	{
		Document axmlDom = createAxmlDomFromRewrittenADocumentAndOriginalDom(rewrittenADoc, originalDom);
		StringBuffer axmlFileDataContainer = new StringBuffer(Utilities.DomToStringSerializerWithIdentation(axmlDom));
		FileOutputModule.saveDataFromStringBufferToFile(axmlFileDataContainer, fileName.toString());
	}
	
	public void createAllAxmlFilesFromFilesStoredAtTheRepository(PlanRepository givenPlanRepository, Document originalDom, StringBuffer originalFileName)
	{
		deletePreviousOptimizationFiles();
		Set<ADocument> visitedADocs = givenPlanRepository.getADocsAlreadyVisitedSet();
		Iterator<ADocument> visitedADocsIter = visitedADocs.iterator();
		int counter = 0;
		while(visitedADocsIter.hasNext())
		{
			StringBuffer optimFileName = new StringBuffer(originalFileName);
			optimFileName.insert(optimFileName.indexOf(".xml"), new String("Optim" + counter));
			createAxmlFileFromRewrittenADocumentAndOriginalDom(visitedADocsIter.next(), originalDom, optimFileName);
			counter++;
		}
	}
	
	private void deletePreviousOptimizationFiles()
	{
		File path = new File(".");
		if(path.isDirectory())
		{
			String[] dirContents = path.list();
			for(int i=0; i<dirContents.length; i++)
			{
				if(dirContents[i].endsWith("Optim.xml"))
				{
					File specificFile = new File(dirContents[i]);
					specificFile.delete();
				}
			}
		}
	}
}
