package fr.inria.gemo.axml.optimax.io.output;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import com.sun.org.apache.xerces.internal.util.NamespaceSupport;

import fr.inria.gemo.axml.optimax.Parameters;
import fr.inria.gemo.axml.optimax.adocument.ADNode;
import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.adocument.Service;
import fr.inria.gemo.axml.optimax.adocument.SimpleNode;
import fr.inria.gemo.axml.optimax.helping.Utilities;
import fr.inria.gemo.axml.optimax.info.DefaultNamespaceDeclarator;

public class ConciseADocumentDrawingModule2 {

	private static boolean isUnderRecieve(ADNode givenADnode)
	{
		ADNode father = givenADnode.getFather();
		while(father != null)
		{
			if(father instanceof Service)
			{
				Service serviceFather = (Service) father;
				if(serviceFather.getServiceName().toString().equals("receive"))
					return true;
			}
			father = father.getFather();
		}
		return false;
	}
	
	public static StringBuffer createGraphvizOutput(ADocument givenADoc)
	{
		/// DISABLING MAPPING OF CURR SC ID FROM OLD SERVICES TO NEW
		////////////////////////////////////////// THIS HAS TO BE DELETED!!!!
//		givenADoc.newScCurrNodeIdsToOld.clear();
//		givenADoc.oldScCurrNodeIdsToNew.clear();
		//////////////////////////////////////////THIS HAS TO BE DELETED!!!!
		
		StringBuffer returningStringBuffer = new StringBuffer();
		List<ADNode> nodesToBeVisited = new ArrayList<ADNode>();
		
		NamespaceSupport myNamespaceSupport = DefaultNamespaceDeclarator.getNamespaceSupportWithDefaultNamespaces();
		String streamSrvPrefix = myNamespaceSupport.getPrefix(Parameters.streamSrvURI);
		
		returningStringBuffer.append("graph \"plan\" {\n");
		
		nodesToBeVisited.add(givenADoc.getRootOfADoc());
		while(!nodesToBeVisited.isEmpty())
		{
			ADNode tempNode = nodesToBeVisited.get(0);
			nodesToBeVisited.remove(0);

			if(tempNode.getCurrNodeID().toString().equals("27"))
				System.out.println("xaxa");
			
			String colour = null;
			if(isUnderRecieve(tempNode))
				colour = "dimgrey";
			else if(tempNode instanceof Service)
			{
				Service serviceTempNode = (Service) tempNode;
				if(serviceTempNode.getServiceName().toString().equals("send") || serviceTempNode.getServiceName().toString().equals("receive"))
					colour = "forestgreen";
				else if(serviceTempNode.getServiceName().toString().equals("newNode"))
					colour = "blue3";
				else
					colour = "red";
			}
			else
				colour = "black";
			
			if(tempNode instanceof Service)
			{
				Service serviceTempNode = (Service)tempNode;
				String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getCurrNodeID().toString());
				if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
					currIdInTheGivenAXMLDoc = serviceTempNode.getCurrNodeID().toString();
				
				if(serviceTempNode.getAfterActivated().size() == 0)
					returningStringBuffer.append(serviceTempNode.getCurrNodeID() + " [ label=\"" + "[" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "]:\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\" color=" + colour + ", fontcolor=" + colour + "];\n");
				else
				{
					List<String> rewrittenAfterActivatedList = new ArrayList<String>();
					Iterator<String> afterActivatedIter = serviceTempNode.getAfterActivated().iterator();
					while(afterActivatedIter.hasNext())
					{
						String currAfterActivated = afterActivatedIter.next();
						String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
						if(oldAfterActivated == null || oldAfterActivated.length() == 0)
							oldAfterActivated = currAfterActivated;
						
						rewrittenAfterActivatedList.add(oldAfterActivated);
					}
					
					returningStringBuffer.append(serviceTempNode.getCurrNodeID() + " [ label=\"" + "[" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "]:\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\" [color=salmon, fontcolor=salmon];\n");
				}
			}
			else if(tempNode instanceof SimpleNode)
			{
				SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
				if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
				{
					String nodeData = simpleNodeTempNode.getNodeData().toString();
					if(nodeData.equals(new String(streamSrvPrefix + ":query")))
					{
						nodeData = simpleNodeTempNode.declaration.getDocumentElement().getTextContent();
					}
						
					returningStringBuffer.append(simpleNodeTempNode.getCurrNodeID() + " [ label=\"" + nodeData + "\" [color=" + colour + ", fontcolor=" + colour +"];\n");
				}
				else
				{
					returningStringBuffer.append(simpleNodeTempNode.getCurrNodeID() + " [ label=\"" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\" [color=" + colour + ", fontcolor=" + colour + "];\n");
				}
			}
			
			nodesToBeVisited.addAll(tempNode.getChildren());
		}
		
		nodesToBeVisited.add(givenADoc.getRootOfADoc());
		while(!nodesToBeVisited.isEmpty())
		{
			ADNode tempNode = nodesToBeVisited.get(0);
			nodesToBeVisited.remove(0);
			
			Iterator<ADNode> childIterator = tempNode.getChildren().iterator();
			while(childIterator.hasNext())
			{
				ADNode childNode = childIterator.next();
				nodesToBeVisited.add(childNode);
				
				if(tempNode instanceof Service)
				{
					Service serviceTempNode = (Service)tempNode;
					String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getCurrNodeID().toString());
					if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
						currIdInTheGivenAXMLDoc = serviceTempNode.getCurrNodeID().toString();
					
					returningStringBuffer.append( serviceTempNode.getCurrNodeID() );
				}

				if(tempNode instanceof SimpleNode)
				{
					SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
					returningStringBuffer.append(simpleNodeTempNode.getCurrNodeID());
				}
				
				returningStringBuffer.append(" -- ");
				
				if(childNode instanceof Service)
				{
					Service serviceChildpNode = (Service)childNode;
					String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceChildpNode.getCurrNodeID().toString());
					if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
						currIdInTheGivenAXMLDoc = serviceChildpNode.getCurrNodeID().toString();

					returningStringBuffer.append(serviceChildpNode.getCurrNodeID());
				}

				if(childNode instanceof SimpleNode)
				{
					SimpleNode simpleNodeChildNode = (SimpleNode)childNode; 
					returningStringBuffer.append(simpleNodeChildNode.getCurrNodeID());
				}
				returningStringBuffer.append(" [color=dimgrey] [dir=none];\n");
			}
		}
		returningStringBuffer.append("}");
		
		System.out.println(givenADoc.newScCurrNodeIdsToOld);
		
		return returningStringBuffer;
	}
	
	public static StringBuffer createGraphvizOutput2(ADocument givenADoc)
	{
		/// DISABLING MAPPING OF CURR SC ID FROM OLD SERVICES TO NEW
		////////////////////////////////////////// THIS HAS TO BE DELETED!!!!
//		givenADoc.newScCurrNodeIdsToOld.clear();
//		givenADoc.oldScCurrNodeIdsToNew.clear();
		//////////////////////////////////////////THIS HAS TO BE DELETED!!!!
		
		StringBuffer returningStringBuffer = new StringBuffer();
		List<ADNode> nodesToBeVisited = new ArrayList<ADNode>();
		
		returningStringBuffer.append("graph \"plan\" {\n");
		
		nodesToBeVisited.add(givenADoc.getRootOfADoc());
		while(!nodesToBeVisited.isEmpty())
		{
			ADNode tempNode = nodesToBeVisited.get(0);
			nodesToBeVisited.remove(0);

			String color = null;
			if(isUnderRecieve(tempNode))
				color = "dimgrey";
			else if(tempNode instanceof Service)
			{
				Service serviceTempNode = (Service) tempNode;
				if(serviceTempNode.getServiceName().toString().equals("send") || serviceTempNode.getServiceName().toString().equals("receive"))
					color = "forestgreen";
				else if(serviceTempNode.getServiceName().toString().equals("newNode"))
					color = "blue3";
				else
					color = "red";
			}
			else
				color = "black";
			
			if(tempNode instanceof Service)
			{
				Service serviceTempNode = (Service)tempNode;
				String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getCurrNodeID().toString());
				if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
					currIdInTheGivenAXMLDoc = serviceTempNode.getCurrNodeID().toString();
				
				if(serviceTempNode.getAfterActivated().size() == 0)
					returningStringBuffer.append("\"" + "[" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\" [color=" + color + ", fontcolor=" + color + "];\n");
				else
				{
					List<String> rewrittenAfterActivatedList = new ArrayList<String>();
					Iterator<String> afterActivatedIter = serviceTempNode.getAfterActivated().iterator();
					while(afterActivatedIter.hasNext())
					{
						String currAfterActivated = afterActivatedIter.next();
						String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
						if(oldAfterActivated == null || oldAfterActivated.length() == 0)
							oldAfterActivated = currAfterActivated;
						
						rewrittenAfterActivatedList.add(oldAfterActivated);
					}
					
					returningStringBuffer.append("\"" + "[" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\" [color=salmon, fontcolor=salmon];\n");
				}
			}
			else if(tempNode instanceof SimpleNode)
			{
				SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
				if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
					returningStringBuffer.append("\"" + "[" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getNodeData() + "\" [color=" + color + ", fontcolor=" + color +"];\n");
				else
				{
					returningStringBuffer.append("\"" + "[" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\" [color=" + color + ", fontcolor=" + color + "];\n");
				}
			}
			
			nodesToBeVisited.addAll(tempNode.getChildren());
		}
		
		nodesToBeVisited.add(givenADoc.getRootOfADoc());
		while(!nodesToBeVisited.isEmpty())
		{
			ADNode tempNode = nodesToBeVisited.get(0);
			nodesToBeVisited.remove(0);
			
			Iterator<ADNode> childIterator = tempNode.getChildren().iterator();
			while(childIterator.hasNext())
			{
				ADNode childNode = childIterator.next();
				nodesToBeVisited.add(childNode);
				
				if(tempNode instanceof Service)
				{
					Service serviceTempNode = (Service)tempNode;
					String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getCurrNodeID().toString());
					if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
						currIdInTheGivenAXMLDoc = serviceTempNode.getCurrNodeID().toString();
					
					if(serviceTempNode.getAfterActivated().size() == 0)
						returningStringBuffer.append("\"" + "[" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\"");
					else
					{
						String currIdOfAfterActivatedInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getAfterActivated().toString());
						if(currIdOfAfterActivatedInTheGivenAXMLDoc == null || currIdOfAfterActivatedInTheGivenAXMLDoc.length() == 0)
							currIdOfAfterActivatedInTheGivenAXMLDoc = serviceTempNode.getAfterActivated().toString();
						
						List<String> rewrittenAfterActivatedList = new ArrayList<String>();
						Iterator<String> afterActivatedIter = serviceTempNode.getAfterActivated().iterator();
						while(afterActivatedIter.hasNext())
						{
							String currAfterActivated = afterActivatedIter.next();
							String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
							if(oldAfterActivated == null || oldAfterActivated.length() == 0)
								oldAfterActivated = currAfterActivated;
							
							rewrittenAfterActivatedList.add(oldAfterActivated);
						}
						
						returningStringBuffer.append("\"" + "[" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\"");
					}
				}

				if(tempNode instanceof SimpleNode)
				{
					SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
					if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
						returningStringBuffer.append("\"" + "[" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getNodeData() + "\"");
					else
						returningStringBuffer.append("\"" + "[" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\"");
				}
				
				returningStringBuffer.append(" -- ");
				
				if(childNode instanceof Service)
				{
					Service serviceChildpNode = (Service)childNode;
					String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceChildpNode.getCurrNodeID().toString());
					if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
						currIdInTheGivenAXMLDoc = serviceChildpNode.getCurrNodeID().toString();
					
					if(serviceChildpNode.getAfterActivated().size() == 0)
						returningStringBuffer.append("\"" + "[" + currIdInTheGivenAXMLDoc + "." + serviceChildpNode.getCurrDocID() + "." + serviceChildpNode.getCurrPeerID() + "\\n" + serviceChildpNode.getOrigNodeID() + "." + serviceChildpNode.getOrigDocID() + "." + serviceChildpNode.getOrigPeerID() + "] (" + serviceChildpNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceChildpNode.getServiceName() + "@" + serviceChildpNode.getExecutionPeer() + "\"\n");
					else
					{
						List<String> rewrittenAfterActivatedList = new ArrayList<String>();
						Iterator<String> afterActivatedIter = serviceChildpNode.getAfterActivated().iterator();
						while(afterActivatedIter.hasNext())
						{
							String currAfterActivated = afterActivatedIter.next();
							String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
//							String oldAfterActivated = new String();
							if(oldAfterActivated == null || oldAfterActivated.length() == 0)
								oldAfterActivated = currAfterActivated;
							
							rewrittenAfterActivatedList.add(oldAfterActivated);
						}
						
						returningStringBuffer.append("\"" + "[" + currIdInTheGivenAXMLDoc + "." + serviceChildpNode.getCurrDocID() + "." + serviceChildpNode.getCurrPeerID() + "\\n" + serviceChildpNode.getOrigNodeID() + "." + serviceChildpNode.getOrigDocID() + "." + serviceChildpNode.getOrigPeerID() + "] (" + serviceChildpNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceChildpNode.getServiceName() + "@" + serviceChildpNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\"\n");
					}
				}

				if(childNode instanceof SimpleNode)
				{
					SimpleNode simpleNodeChildNode = (SimpleNode)childNode; 
					if(simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
						returningStringBuffer.append("\"" + "[" + simpleNodeChildNode.getCurrNodeID() + "." + simpleNodeChildNode.getCurrDocID() + "." + simpleNodeChildNode.getCurrPeerID() + "] :\\n" + simpleNodeChildNode.getNodeData() + "\"\n");
					else
						returningStringBuffer.append("\"" + "[" + simpleNodeChildNode.getCurrNodeID() + "." + simpleNodeChildNode.getCurrDocID() + "." + simpleNodeChildNode.getCurrPeerID() + "] :\\n" + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().host + "\"\n");
				}
			}
		}
		returningStringBuffer.append("}");
		
		System.out.println(givenADoc.newScCurrNodeIdsToOld);
		
		return returningStringBuffer;
	}
	
	public static void createOutputImage(ADocument givenADocument, String fileName)
	{
//		deletePreviousTxtAndJpgFiles();
		FileOutputModule.saveDataFromStringBufferToFile(createGraphvizOutput(givenADocument), new String(fileName + ".txt"));
		GraphvizModule.runGraphviz(fileName);
	}
}
