package fr.inria.gemo.axml.optimax.io.output;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.PrintWriter;

import org.w3c.dom.Document;

import fr.inria.gemo.axml.optimax.PlanRepository;
import fr.inria.gemo.axml.optimax.Parameters;
import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.helping.Deleting;


public class FileOutputModule {
	private ADocumentDrawingModule aDocumentDrawingModuleInstance = null;
	private AxmlFileOutputModule axmlFileOutputModuleInstance = null;
	private CostPlotModule costPlotModuleInstance = null;
	
	public FileOutputModule() 
	{
		aDocumentDrawingModuleInstance = new ADocumentDrawingModule();
		axmlFileOutputModuleInstance = new AxmlFileOutputModule();
	}
	
	public void createOutputImages(PlanRepository givenPlanRepository)
	{
		aDocumentDrawingModuleInstance.createOutputImages(givenPlanRepository);
	}

	public void createGnuPlotGraphs(PlanRepository givenPlanRepository)
	{
		costPlotModuleInstance = new CostPlotModule();
		costPlotModuleInstance.createGnuPlotGraphs();
	}
	
	public static void createDebugOutputImage(ADocument givenADocument, String fileName)
	{
		VerboseADocumentDrawingModule.createOutputImage(givenADocument, fileName);
	}
	
	public void createOptimizationFiles(PlanRepository givenPlanRepository, Document originalDom, StringBuffer originalFileName)
	{
		axmlFileOutputModuleInstance.createAllAxmlFilesFromFilesStoredAtTheRepository(givenPlanRepository, originalDom, originalFileName);
	}
	
	public static void deletePreviousTxtAndJpgFiles()
	{
		Deleting.deletePreviousTxtAndJpgFiles();
	}
	
	public static void saveDataFromStringBufferToFile(StringBuffer dataToSave, String fileName)
	{
		try
		{
		  PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(Parameters.OUTPUT_DIR + fileName)));
		  out.append(dataToSave.toString());
		  out.flush();
		  out.close();
		}
		catch(Exception e)
		{
			System.err.println(e);
		}
	}
}
