package fr.inria.gemo.axml.optimax.io.output;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.HashMap;

import fr.inria.gemo.axml.optimax.PlanRepository;
import fr.inria.gemo.axml.optimax.Parameters;
import fr.inria.gemo.axml.optimax.adocument.ADNode;
import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.adocument.Service;
import fr.inria.gemo.axml.optimax.adocument.SimpleNode;
import fr.inria.gemo.axml.optimax.helping.comparators.ComparatorSimpleNetwCost;

public class GraphvizModule {
	
	public static void runGraphviz(String fileName) 
	{
	     List<String> command = new ArrayList<String>();
	     command.add("dot");
	     command.add(Parameters.OUTPUT_DIR + fileName + ".txt");
	     command.add("-Tjpg");
	     command.add("-o");
	     command.add(Parameters.OUTPUT_DIR + fileName + ".jpg");
	     
	     ProcessBuilder builder = new ProcessBuilder(command);
	     File currDir = new File(".");
	     builder.directory(currDir);

	     try 
	     {
			@SuppressWarnings("unused")
			final Process process = builder.start();
			process.waitFor();
	     } 
	     catch (IOException e) 
	     {
			// TODO Auto-generated catch block
			e.printStackTrace();
	     } catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
