package fr.inria.gemo.axml.optimax.io.output;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import fr.inria.gemo.axml.optimax.Parameters;
import fr.inria.gemo.axml.optimax.PlanRepository;
import fr.inria.gemo.axml.optimax.adocument.ADNode;
import fr.inria.gemo.axml.optimax.adocument.ADocument;
import fr.inria.gemo.axml.optimax.adocument.Service;
import fr.inria.gemo.axml.optimax.adocument.SimpleNode;
import fr.inria.gemo.axml.optimax.helping.comparators.ComparatorSimpleNetwCost;

public class VerboseADocumentDrawingModule {

	public static StringBuffer createGraphvizOutput(ADocument givenADoc)
	{
		/// DISABLING MAPPING OF CURR SC ID FROM OLD SERVICES TO NEW
		////////////////////////////////////////// THIS HAS TO BE DELETED!!!!
//		givenADoc.newScCurrNodeIdsToOld.clear();
//		givenADoc.oldScCurrNodeIdsToNew.clear();
		//////////////////////////////////////////THIS HAS TO BE DELETED!!!!
		
		StringBuffer returningStringBuffer = new StringBuffer();
		List<ADNode> nodesToBeVisited = new ArrayList<ADNode>();
		
		returningStringBuffer.append("graph \"plan\" {graph [fontsize = 16, label = \"\\n\\nDocument @ " + givenADoc.getPeerThatHostsADoc() + " , SimpleNetworkCost: " + givenADoc.getSimpleNetworkCost() + " , RealNetworkCost: " + givenADoc.getServiceAndWeightedNetworkCost1() + "\\nNumber Of Rewritings: " + givenADoc.getNumberOfRewritings() + " , Number Of GeneralizationInstatiations: " + givenADoc.getNumberOfGeneralizationInstatiations() + " , Number Of Delegations: " + givenADoc.getNumberOfDelegations() + "\\nNumber Of CSE: " + givenADoc.getNumberOfCSE() + " , Number Of Nodes: " + givenADoc.getNumberOfNodes() + "\\nADoc Number: " + givenADoc.getADocNumber() + " , Applied Rules: " + givenADoc.getRulesAppliedToString() + "\", size = \"50,50\"]; node [style=filled];\n");
		
		nodesToBeVisited.add(givenADoc.getRootOfADoc());
		while(!nodesToBeVisited.isEmpty())
		{
			ADNode tempNode = nodesToBeVisited.get(0);
			nodesToBeVisited.remove(0);

			if(tempNode instanceof Service)
			{
				Service serviceTempNode = (Service)tempNode;
				String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getCurrNodeID().toString());
				if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
					currIdInTheGivenAXMLDoc = serviceTempNode.getCurrNodeID().toString();
				
				if(serviceTempNode.getAfterActivated().size() == 0)
					returningStringBuffer.append("\"" + "[#" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\" [color=salmon2];\n");
				else
				{
					List<String> rewrittenAfterActivatedList = new ArrayList<String>();
					Iterator<String> afterActivatedIter = serviceTempNode.getAfterActivated().iterator();
					while(afterActivatedIter.hasNext())
					{
						String currAfterActivated = afterActivatedIter.next();
						String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
						if(oldAfterActivated == null || oldAfterActivated.length() == 0)
							oldAfterActivated = currAfterActivated;
						
						rewrittenAfterActivatedList.add(oldAfterActivated);
					}
					
					returningStringBuffer.append("\"" + "[#" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\" [color=salmon2];\n");
				}
			}
			else if(tempNode instanceof SimpleNode)
			{
				SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
				if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
					returningStringBuffer.append("\"" + "[#" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getNodeData() + "\" [color=lightblue2];\n");
				else
				{
					returningStringBuffer.append("\"" + "[#" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\" [color=lightblue2];\n");
				}
			}
			
			nodesToBeVisited.addAll(tempNode.getChildren());
		}
		
		nodesToBeVisited.add(givenADoc.getRootOfADoc());
		while(!nodesToBeVisited.isEmpty())
		{
			ADNode tempNode = nodesToBeVisited.get(0);
			nodesToBeVisited.remove(0);
			
			Iterator<ADNode> childIterator = tempNode.getChildren().iterator();
			while(childIterator.hasNext())
			{
				ADNode childNode = childIterator.next();
				nodesToBeVisited.add(childNode);
				
				if(tempNode instanceof Service)
				{
					Service serviceTempNode = (Service)tempNode;
					String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getCurrNodeID().toString());
					if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
						currIdInTheGivenAXMLDoc = serviceTempNode.getCurrNodeID().toString();
					
					if(serviceTempNode.getAfterActivated().size() == 0)
						returningStringBuffer.append("\"" + "[#" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\"");
					else
					{
						String currIdOfAfterActivatedInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceTempNode.getAfterActivated().toString());
						if(currIdOfAfterActivatedInTheGivenAXMLDoc == null || currIdOfAfterActivatedInTheGivenAXMLDoc.length() == 0)
							currIdOfAfterActivatedInTheGivenAXMLDoc = serviceTempNode.getAfterActivated().toString();
						
						List<String> rewrittenAfterActivatedList = new ArrayList<String>();
						Iterator<String> afterActivatedIter = serviceTempNode.getAfterActivated().iterator();
						while(afterActivatedIter.hasNext())
						{
							String currAfterActivated = afterActivatedIter.next();
							String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
							if(oldAfterActivated == null || oldAfterActivated.length() == 0)
								oldAfterActivated = currAfterActivated;
							
							rewrittenAfterActivatedList.add(oldAfterActivated);
						}
						
						returningStringBuffer.append("\"" + "[#" + currIdInTheGivenAXMLDoc + "." + serviceTempNode.getCurrDocID() + "." + serviceTempNode.getCurrPeerID() + "\\n" + serviceTempNode.getOrigNodeID() + "." + serviceTempNode.getOrigDocID() + "." + serviceTempNode.getOrigPeerID() + "] (" + serviceTempNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\"");
					}
				}

				if(tempNode instanceof SimpleNode)
				{
					SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
					if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
						returningStringBuffer.append("\"" + "[#" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getNodeData() + "\"");
					else
						returningStringBuffer.append("\"" + "[#" + simpleNodeTempNode.getCurrNodeID() + "." + simpleNodeTempNode.getCurrDocID() + "." + simpleNodeTempNode.getCurrPeerID() + "] :\\n" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\"");
				}
				
				returningStringBuffer.append(" -- ");
				
				if(childNode instanceof Service)
				{
					Service serviceChildpNode = (Service)childNode;
					String currIdInTheGivenAXMLDoc = givenADoc.newScCurrNodeIdsToOld.get(serviceChildpNode.getCurrNodeID().toString());
					if(currIdInTheGivenAXMLDoc == null || currIdInTheGivenAXMLDoc.length() == 0)
						currIdInTheGivenAXMLDoc = serviceChildpNode.getCurrNodeID().toString();
					
					if(serviceChildpNode.getAfterActivated().size() == 0)
						returningStringBuffer.append("\"" + "[#" + currIdInTheGivenAXMLDoc + "." + serviceChildpNode.getCurrDocID() + "." + serviceChildpNode.getCurrPeerID() + "\\n" + serviceChildpNode.getOrigNodeID() + "." + serviceChildpNode.getOrigDocID() + "." + serviceChildpNode.getOrigPeerID() + "] (" + serviceChildpNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceChildpNode.getServiceName() + "@" + serviceChildpNode.getExecutionPeer() + "\"\n");
					else
					{
						List<String> rewrittenAfterActivatedList = new ArrayList<String>();
						Iterator<String> afterActivatedIter = serviceChildpNode.getAfterActivated().iterator();
						while(afterActivatedIter.hasNext())
						{
							String currAfterActivated = afterActivatedIter.next();
							String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
//							String oldAfterActivated = new String();
							if(oldAfterActivated == null || oldAfterActivated.length() == 0)
								oldAfterActivated = currAfterActivated;
							
							rewrittenAfterActivatedList.add(oldAfterActivated);
						}
						
						returningStringBuffer.append("\"" + "[#" + currIdInTheGivenAXMLDoc + "." + serviceChildpNode.getCurrDocID() + "." + serviceChildpNode.getCurrPeerID() + "\\n" + serviceChildpNode.getOrigNodeID() + "." + serviceChildpNode.getOrigDocID() + "." + serviceChildpNode.getOrigPeerID() + "] (" + serviceChildpNode.getHashCodeOfTreeRootedByCurrService() + ") :\\n" + serviceChildpNode.getServiceName() + "@" + serviceChildpNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\"\n");
					}
				}

				if(childNode instanceof SimpleNode)
				{
					SimpleNode simpleNodeChildNode = (SimpleNode)childNode; 
					if(simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
						returningStringBuffer.append("\"" + "[#" + simpleNodeChildNode.getCurrNodeID() + "." + simpleNodeChildNode.getCurrDocID() + "." + simpleNodeChildNode.getCurrPeerID() + "] :\\n" + simpleNodeChildNode.getNodeData() + "\"\n");
					else
						returningStringBuffer.append("\"" + "[#" + simpleNodeChildNode.getCurrNodeID() + "." + simpleNodeChildNode.getCurrDocID() + "." + simpleNodeChildNode.getCurrPeerID() + "] :\\n" + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().host + "\"\n");
				}
			}
		}
		returningStringBuffer.append("}");
		
		System.out.println(givenADoc.newScCurrNodeIdsToOld);
		
		return returningStringBuffer;
	}
	
//	private static StringBuffer createDebugGraphvizOutput(ADocument givenADoc)
//	{
//		StringBuffer returningStringBuffer = new StringBuffer();
//		List<ADNode> nodesToBeVisited = new ArrayList<ADNode>();
//		
//		returningStringBuffer.append("graph \"plan\" {graph [fontsize = 16, label = \"\\n\\nDocument @ " + givenADoc.getPeerThatHostsADoc() + "\", size = \"30,30\"]; node [style=filled];");
//		
//		nodesToBeVisited.add(givenADoc.getRootOfADoc());
//		while(!nodesToBeVisited.isEmpty())
//		{
//			ADNode tempNode = nodesToBeVisited.get(0);
//			nodesToBeVisited.remove(0);
//
//			int fatherHashCode = 0;
//			if(tempNode.getFather() != null)
//				fatherHashCode = tempNode.getFather().originalHashCode();
//			
//			StringBuffer childrenHashCodes = new StringBuffer();
//			for(int i=0; i<tempNode.getChildren().size(); i++)
//			{
//				if(i == 0)
//					childrenHashCodes.append("[");
//				childrenHashCodes.append(tempNode.getChildren().get(i).originalHashCode());
//				if(i != tempNode.getChildren().size() - 1)
//					childrenHashCodes.append(",");
//				else
//					childrenHashCodes.append("]");
//			}
//			
//			if(tempNode instanceof Service)
//			{
//				Service serviceTempNode = (Service)tempNode;
//				if(serviceTempNode.getAfterActivated().size() == 0)
//					returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + serviceTempNode.originalHashCode() + "] " + childrenHashCodes + ": " + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\" [color=salmon2];");
//				else
//				{
//					List<String> rewrittenAfterActivatedList = new ArrayList<String>();
//					Iterator<String> afterActivatedIter = serviceTempNode.getAfterActivated().iterator();
//					while(afterActivatedIter.hasNext())
//					{
//						String currAfterActivated = afterActivatedIter.next();
//						String oldAfterActivated = givenADoc.newScCurrNodeIdsToOld.get(currAfterActivated);
//						if(oldAfterActivated == null || oldAfterActivated.length() == 0)
//							oldAfterActivated = currAfterActivated;
//						
//						rewrittenAfterActivatedList.add(oldAfterActivated);
//					}
//					
//					returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + serviceTempNode.originalHashCode() + "] " + childrenHashCodes + ": " + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + rewrittenAfterActivatedList + "\" [color=salmon2];");
//				}
//			}
//			else if(tempNode instanceof SimpleNode)
//			{
//				SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
//				if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
//					returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + simpleNodeTempNode.originalHashCode() + "] " + childrenHashCodes + ": " + simpleNodeTempNode.getNodeData() + "\" [color=lightblue2];");
//				else
//					returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + simpleNodeTempNode.originalHashCode() + "] " + childrenHashCodes + ": " + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\" [color=lightblue2];");
//			}
//			
//			nodesToBeVisited.addAll(tempNode.getChildren());
//		}
//		
//		nodesToBeVisited.add(givenADoc.getRootOfADoc());
//		while(!nodesToBeVisited.isEmpty())
//		{
//			ADNode tempNode = nodesToBeVisited.get(0);
//			nodesToBeVisited.remove(0);
//			
//			StringBuffer childrenHashCodesOfTempNode = new StringBuffer();
//			for(int i=0; i<tempNode.getChildren().size(); i++)
//			{
//				if(i == 0)
//					childrenHashCodesOfTempNode.append("[");
//				childrenHashCodesOfTempNode.append(tempNode.getChildren().get(i).originalHashCode());
//				if(i != tempNode.getChildren().size() - 1)
//					childrenHashCodesOfTempNode.append(",");
//				else
//					childrenHashCodesOfTempNode.append("]");
//			}
//			
//			Iterator<ADNode> childIterator = tempNode.getChildren().iterator();
//			while(childIterator.hasNext())
//			{
//				ADNode childNode = childIterator.next();
//				nodesToBeVisited.add(childNode);
//				
//				int fatherHashCode = 0;
//				if(tempNode.getFather() != null)
//					fatherHashCode = tempNode.getFather().originalHashCode();
//				
//				if(tempNode instanceof Service)
//				{
//					Service serviceTempNode = (Service)tempNode;
//					if(serviceTempNode.getAfterActivated().size() == 0)
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + serviceTempNode.originalHashCode() + "] " + childrenHashCodesOfTempNode + ": " + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + "\"");
//					else
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + serviceTempNode.originalHashCode() + "] " + childrenHashCodesOfTempNode + ": " + serviceTempNode.getServiceName() + "@" + serviceTempNode.getExecutionPeer() + ", afterActivated " + serviceTempNode.getAfterActivated() + "\"");
//				}
//
//				if(tempNode instanceof SimpleNode)
//				{
//					SimpleNode simpleNodeTempNode = (SimpleNode)tempNode;
//					if(simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + simpleNodeTempNode.originalHashCode() + "] " + childrenHashCodesOfTempNode + ": " + simpleNodeTempNode.getNodeData() + "\"");
//					else
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + simpleNodeTempNode.originalHashCode() + "] " + childrenHashCodesOfTempNode + ": " + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeTempNode.getRemoteOriginalIdAndHostingPeer().host + "\"");
//				}
//				
//				returningStringBuffer.append(" -- ");
//				fatherHashCode = 0;
//				if(childNode.getFather() != null)
//					fatherHashCode = childNode.getFather().originalHashCode();
//				
//				StringBuffer childrenHashCodesOfChildren = new StringBuffer();
//				for(int i=0; i<childNode.getChildren().size(); i++)
//				{
//					if(i == 0)
//						childrenHashCodesOfChildren.append("[");
//					childrenHashCodesOfChildren.append(childNode.getChildren().get(i).originalHashCode());
//					if(i != childNode.getChildren().size() - 1)
//						childrenHashCodesOfChildren.append(",");
//					else
//						childrenHashCodesOfChildren.append("]");
//				}
//				
//				if(childNode instanceof Service)
//				{
//					Service serviceChildpNode = (Service)childNode; 
//					if(serviceChildpNode.getAfterActivated().size() == 0)
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + serviceChildpNode.originalHashCode() + "] " + childrenHashCodesOfChildren + ": " + serviceChildpNode.getServiceName() + "@" + serviceChildpNode.getExecutionPeer() + "\"");
//					else
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + serviceChildpNode.originalHashCode() + "] " + childrenHashCodesOfChildren + ": " + serviceChildpNode.getServiceName() + "@" + serviceChildpNode.getExecutionPeer() + ", afterActivated " + serviceChildpNode.getAfterActivated() + "\"");
//
//				}
//
//				if(childNode instanceof SimpleNode)
//				{
//					SimpleNode simpleNodeChildNode = (SimpleNode)childNode; 
//					if(simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().isEmpty())
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + simpleNodeChildNode.originalHashCode() + "] " + childrenHashCodesOfChildren + ": " + simpleNodeChildNode.getNodeData() + "\"");
//					else
//						returningStringBuffer.append("\"" + "[#(" + fatherHashCode + ") " + simpleNodeChildNode.originalHashCode() + "] " + childrenHashCodesOfChildren + ": " + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.nodeID + "." + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.docID + "." + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().id.peerID + "@" + simpleNodeChildNode.getRemoteOriginalIdAndHostingPeer().host + "\"");
//				}
//			}
//		}
//		returningStringBuffer.append("}");
//		return returningStringBuffer;
//	}
//	
//	public static void createDebugOutputImage(ADocument givenADocument, String fileName)
//	{
////		deletePreviousTxtAndJpgFiles();
//		FileOutputModule.saveDataFromStringBufferToFile(createDebugGraphvizOutput(givenADocument), new String(fileName + ".txt"));
//		GraphvizModule.runGraphviz(fileName);
//	}
	
	public static void createOutputImage(ADocument givenADocument, String fileName)
	{
//		deletePreviousTxtAndJpgFiles();
		FileOutputModule.saveDataFromStringBufferToFile(createGraphvizOutput(givenADocument), new String(fileName + ".txt"));
		GraphvizModule.runGraphviz(fileName);
	}
}
